﻿using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// ANSI 인코딩
    /// </summary>
    internal class ANSIEncoding : Encoding
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// 인스턴스
        /// </summary>
        public static ANSIEncoding Instance = new ANSIEncoding();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - GetString(byteArray, index, count)

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <param name="byteArray">바이트 배열</param>
        /// <param name="index">인덱스</param>
        /// <param name="count">카운트</param>
        /// <returns>문자열</returns>
        public override string GetString(byte[] byteArray, int index, int count)
        {
            StringBuilder stringBuilder = new StringBuilder();

            int endIndex = Math.Min(byteArray.Length-1, index + count -1);

            for(int i = index ; i <= endIndex ; i++)
            {
                stringBuilder.Append(System.Convert.ToChar(byteArray[i]));
            }

            return stringBuilder.ToString();
        }

        #endregion
        #region 바이트 카운트 구하기 - GetByteCount(characterArray, characterArrayIndex, characterArrayCount)

        /// <summary>
        /// 바이트 카운트 구하기
        /// </summary>
        /// <param name="characterArray">문자 배열</param>
        /// <param name="characterArrayIndex">문자 배열 인덱스</param>
        /// <param name="characterArrayCount">문자 배열 카운트</param>
        /// <returns>바이트 카운트</returns>
        public override int GetByteCount(char[] characterArray, int characterArrayIndex, int characterArrayCount)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
        #region 바이트 배열 구하기 - GetBytes(characterArray, characterArrayIndex, characterArrayCount, byteArray, byteArrayIndex)

        /// <summary>
        /// 바이트 배열 구하기
        /// </summary>
        /// <param name="characterArray">문자 배열</param>
        /// <param name="characterArrayIndex">문자 배열 인덱스</param>
        /// <param name="characterArrayCount">문자 배열 카운트</param>
        /// <param name="byteArray">바이트 배열</param>
        /// <param name="byteArrayIndex">바이트 배열 인덱스</param>
        /// <returns>바이트 배열 카운트</returns>
        public override int GetBytes(char[] characterArray, int characterArrayIndex, int characterArrayCount, byte[] byteArray, int byteArrayIndex)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
        #region 최대 바이트 카운트 구하기 - GetMaxByteCount(characterCount)

        /// <summary>
        /// 최대 바이트 카운트 구하기
        /// </summary>
        /// <param name="characterCount">문자 카운트</param>
        /// <returns>최대 바이트 카운트</returns>
        public override int GetMaxByteCount(int characterCount)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
        #region 문자 카운트 구하기 - GetCharCount(byteArray, byteArrayIndex, byteArrayCount)

        /// <summary>
        /// 문자 카운트 구하기
        /// </summary>
        /// <param name="byteArray">바이트 배열</param>
        /// <param name="byteArrayIndex">바이트 배열 인덱스</param>
        /// <param name="byteArrayCount">바이트 배열 카운트</param>
        /// <returns>문자 카운트</returns>
        public override int GetCharCount(byte[] byteArray, int byteArrayIndex, int byteArrayCount)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
        #region 문자 배열 구하기 - GetChars(byteArray, byteArrayIndex, byteArrayCount, characterArray, characterArrayIndex)

        /// <summary>
        /// 문자 배열 구하기
        /// </summary>
        /// <param name="byteArray">바이트 배열</param>
        /// <param name="byteArrayIndex">바이트 배열 인덱스</param>
        /// <param name="byteArrayCount">바이트 배열 카운트</param>
        /// <param name="characterArray">문자 배열</param>
        /// <param name="characterArrayIndex">문자 배열 인덱스</param>
        /// <returns>문자 배열 카운트</returns>
        public override int GetChars(byte[] byteArray, int byteArrayIndex, int byteArrayCount, char[] characterArray, int characterArrayIndex)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
        #region 최대 문자 카운트 구하기 - GetMaxCharCount(byteCount)

        /// <summary>
        /// 최대 문자 카운트 구하기
        /// </summary>
        /// <param name="byteCount">바이트 카운트</param>
        /// <returns>최대 문자 카운트</returns>
        public override int GetMaxCharCount(int byteCount)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
    }
}