using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// Ʈ 
    /// </summary>
    public class ByteBuffer
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region Field

        /// <summary>
        /// īƮ
        /// </summary>
        protected int count = 0;

        /// <summary>
        /// byte array 
        /// </summary>
        protected byte[] bufferByteArray = new byte[16];

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region īƮ - Count

        /// <summary>
        /// īƮ
        /// </summary>
        public virtual int Count
        {
            get
            {
                return this.count;
            }
        }

        #endregion
        #region ε - this[index]

        /// <summary>
        /// ε
        /// </summary>
        /// <param name="index">ε</param>
        /// <returns></returns>
        public byte this[int index]
        {
            get
            {
                if(index >= 0 && index < this.count)
                {
                    return this.bufferByteArray[index];
                }
                else
                {
                    throw new IndexOutOfRangeException("index");
                }
            }
            set
            {
                if(index >= 0 && index < this.count)
                {
                    this.bufferByteArray[index] = value;
                }
                else
                {
                    throw new IndexOutOfRangeException("index");
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - ByteBuffer()

        /// <summary>
        /// 
        /// </summary>
        public ByteBuffer()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ߰ϱ - Add(value)

        /// <summary>
        /// ߰ϱ
        /// </summary>
        /// <param name="value"></param>
        public void Add(byte value)
        {
            FixBuffer(this.count + 1);

            this.bufferByteArray[this.count] = value;

            this.count ++;
        }

        #endregion
        #region ߰ϱ - Add(valueArray)

        /// <summary>
        /// ߰ϱ
        /// </summary>
        /// <param name="valueArray"> 迭</param>
        public void Add(byte[] valueArray)
        {
            if(valueArray != null)
            {
                Add(valueArray , 0 , valueArray.Length);
            }
        }

        #endregion
        #region ߰ϱ - Add(valueArray , startIndex , length)

        /// <summary>
        /// ߰ϱ
        /// </summary>
        /// <param name="valueArray"> 迭</param>
        /// <param name="startIndex"> ε</param>
        /// <param name="length"></param>
        public void Add(byte[] valueArray , int startIndex , int length)
        {
            if(valueArray != null && startIndex >= 0 && (startIndex + length) <= valueArray.Length && length > 0)
            {
                FixBuffer(this.count + length);

                Array.Copy(valueArray , startIndex , this.bufferByteArray , this.count , length);

                this.count += length;
            }
        }

        #endregion
        #region ϱ - Reset()

        /// <summary>
        /// ϱ
        /// </summary>
        public void Reset()
        {
            this.count = 0;
        }

        #endregion
        #region  - Clear()

        /// <summary>
        /// 
        /// </summary>
        public virtual void Clear()
        {
            this.bufferByteArray = new byte[16];
            this.count           = 0;
        }

        #endregion
        #region 迭 ϱ - ToArray()

        /// <summary>
        /// 迭 ϱ
        /// </summary>
        /// <returns>迭</returns>
        public byte[] ToArray()
        {
            if(this.count > 0)
            {
                byte[] byteArray = new byte[this.count];

                Array.Copy(this.bufferByteArray , 0 , byteArray , 0 , this.count);

                return byteArray;
            }
            else
            {
                return null;
            }
        }

        #endregion
        #region ڿ ϱ - GetString(encoding)

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <param name="encoding">ڵ</param>
        /// <returns>ڿ</returns>
        public string GetString(Encoding encoding)
        {
            if(encoding == null)
            {
                throw new ArgumentNullException("encoding");
            }

            if(this.count > 0)
            {
                return encoding.GetString(this.bufferByteArray , 0 , this.count);
            }
            else
            {
                return String.Empty;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  ϱ - FixBuffer(newSize)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="newSize">ű ũ</param>
        protected void FixBuffer(int newSize)
        {
            if(newSize <= this.bufferByteArray.Length)
            {
                return;
            }

            if(newSize < (int)(this.bufferByteArray.Length * 1.5))
            {
                newSize = (int)(this.bufferByteArray.Length * 1.5);
            }

            byte[] byteArray = new byte[newSize];

            Buffer.BlockCopy(this.bufferByteArray , 0 , byteArray , 0 , this.bufferByteArray.Length);

            this.bufferByteArray = byteArray;
        }

        #endregion
    }
}