﻿using System;

namespace TestLibrary
{
    /// <summary>
    /// 진행 이벤트 인자
    /// </summary>
    public class ProgressEventArgs : EventArgs 
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 최대 값
        /// </summary>
        private int maximumValue = 0;

        /// <summary>
        /// 값
        /// </summary>
        private int value = 0;

        /// <summary>
        /// 메시지
        /// </summary>
        private string message = null;

        /// <summary>
        /// 취소 여부
        /// </summary>
        private bool cancel = false;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 최대 값 - MaximumValue

        /// <summary>
        /// 최대 값
        /// </summary>
        public int MaximumValue
        {
            get
            {
                return this.maximumValue;
            }
        }

        #endregion
        #region 값 - Value

        /// <summary>
        /// 값
        /// </summary>
        public int Value
        {
            get
            {
                return this.value;
            }
        }

        #endregion
        #region 메시지 - Message

        /// <summary>
        /// 메시지
        /// </summary>
        public string Message
        {
            get
            {
                return this.message; 
            }
        }

        #endregion
        #region 취소 여부 - Cancel

        /// <summary>
        /// 취소 여부
        /// </summary>
        public bool Cancel
        {
            get
            {
                return this.cancel;
            }
            set
            {
                this.cancel = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ProgressEventArgs(maximumValue, value, message)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="maximumValue">최대 값</param>
        /// <param name="value">값</param>
        /// <param name="message">메시지</param>
        public ProgressEventArgs(int maximumValue, int value, string message)
        {
            this.maximumValue = maximumValue;
            this.value        = value;
            this.message      = message;
        }

        #endregion
    }
}