using System.Collections.Generic;
using System.Diagnostics;
using System.Drawing;

namespace TestLibrary
{
    /// <summary>
    /// RTF  ̺
    /// </summary>
    [DebuggerDisplay("Count={Count}")]
    [DebuggerTypeProxy(typeof(RTFInstanceDebugView))]
    public class RTFColorTable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///  Ʈ
        /// </summary>
        private List<Color> list = new List<Color>();

        /// <summary>
        /// ߰   üũ 
        /// </summary>
        private bool checkValueExistWhenAdd = true;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ε - this[index]

        /// <summary>
        /// ε
        /// </summary>
        public Color this[int index]
        {
            get
            {
                return this.list[index];
            }
        }

        #endregion
        #region ߰   üũ  - CheckValueExistWhenAdd

        /// <summary>
        /// ߰   üũ 
        /// </summary>
        public bool CheckValueExistWhenAdd
        {
            get
            {
                return this.checkValueExistWhenAdd; 
            }
            set
            {
                this.checkValueExistWhenAdd = value; 
            }
        }

        #endregion
        #region īƮ - Count

        /// <summary>
        /// īƮ
        /// </summary>
        public int Count
        {
            get
            {
                return this.list.Count;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFColorTable()

        /// <summary>
        /// 
        /// </summary>
        public RTFColorTable()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ߰ϱ - Add(color)

        /// <summary>
        /// ߰ϱ
        /// </summary>
        /// <param name="color"></param>
        public void Add(Color color)
        {
            if(color.IsEmpty)
            {
                return;
            }

            if(color.A == 0)
            {
                return;
            }
            
            if(color.A != 255)
            {
                color = Color.FromArgb(255, color);
            }

            if(this.checkValueExistWhenAdd)
            {
                if(GetIndex(color) < 0)
                {
                    this.list.Add(color);
                }
            }
            else
            {
                this.list.Add(color);
            }
        }

        #endregion
        #region ϱ - Remove(color)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="color"></param>
        public void Remove(Color color)
        {
            int index = GetIndex(color);

            if(index >= 0)
            {
                this.list.RemoveAt(index);
            }
        }

        #endregion
        #region  ϱ - GetColor(index, defaultColor)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="index">ε</param>
        /// <param name="defaultColor">Ʈ </param>
        /// <returns></returns>
        public Color GetColor(int index, Color defaultColor)
        {
            index--;

            if(index >= 0 && index < this.list.Count)
            {
                return this.list[index];
            }
            else
            {
                return defaultColor;
            }
        }

        #endregion
        #region ε ϱ - GetIndex(color)

        /// <summary>
        /// ε ϱ
        /// </summary>
        /// <param name="color"></param>
        /// <returns>ε</returns>
        public int GetIndex(Color color)
        {
            if(color.A == 0)
            {
                return -1;
            }

            if(color.A != 255)
            {
                color = Color.FromArgb(255 , color);
            }

            for(int i = 0; i < this.list.Count; i++)
            {
                if(this.list[i].ToArgb() == color.ToArgb())
                {
                    return i;
                }
            }

            return -1;
        }

        #endregion
        #region  - Write(writer)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="writer">RTF </param>
        public void Write(RTFWriter writer)
        {
            writer.WriteStartGroup();

            writer.WriteKeyword(RTFConstant.COLORTBL);

            writer.WriteRaw(";");

            for(int i = 0; i < this.list.Count; i ++)
            {
                Color color = this.list[i];

                writer.WriteKeyword("red"   + color.R);
                writer.WriteKeyword("green" + color.G);
                writer.WriteKeyword("blue"  + color.B);

                writer.WriteRaw(";");
            }

            writer.WriteEndGroup();
        }

        #endregion
        #region  - Clear()

        /// <summary>
        /// 
        /// </summary>
        public void Clear()
        {
            this.list.Clear();
        }

        #endregion
        #region ϱ - Clone()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF  ̺</returns>
        public RTFColorTable Clone()
        {
            RTFColorTable table = new RTFColorTable();

            for(int i = 0; i < this.list.Count; i++)
            {
                Color color = this.list[i];

                table.list.Add(color);
            }

            return table;
        }

        #endregion
    }
}