using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM 
    /// </summary>
    public partial class RTFDOMDocument : RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Event
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ̺Ʈ - Progress

        /// <summary>
        ///  ̺Ʈ
        /// </summary>
        public event ProgressEventHandler Progress = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// Ʈ Ʈ
        /// </summary>
        private static string _defaultFontName = Control.DefaultFont.Name;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Instance
        //////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        ///   
        /// </summary>
        private string followingCharacters = null;

        /// <summary>
        ///  
        /// </summary>
        private string leadingCharacters = null;

        /// <summary>
        /// Ʈ ڵ
        /// </summary>
        private Encoding defaultEncoding = Encoding.Default;

        /// <summary>
        /// Ʈ  Ʈ ڵ
        /// </summary>
        private Encoding fontChartSetEncoding = null;

        /// <summary>
        ///  Ʈ  Ʈ ڵ
        /// </summary>
        private Encoding associateFontChartSetEncoding = null;

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        private RTFFontTable fontTable = new RTFFontTable();

        /// <summary>
        ///  ̺
        /// </summary>
        private RTFColorTable colorTable = new RTFColorTable();

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        private RTFListTable listTable = new RTFListTable();

        /// <summary>
        /// Ʈ ̵ ̺
        /// </summary>
        private RTFListOverrideTable listOverrideTable = new RTFListOverrideTable();

        /// <summary>
        ///  
        /// </summary>
        private RTFDocumentInfo documentInfo = new RTFDocumentInfo();

        /// <summary>
        /// ʷ
        /// </summary>
        private string generator = null;

        /// <summary>
        ///  ʺ
        /// </summary>
        private int paperWidth = 12240;

        /// <summary>
        ///  
        /// </summary>
        private int paperHeight = 15840;

        /// <summary>
        ///  
        /// </summary>
        private int leftMargin = 1800;

        /// <summary>
        ///  
        /// </summary>
        private int topMargin = 1440;

        /// <summary>
        ///  
        /// </summary>
        private int rightMargin = 1800;

        /// <summary>
        /// Ʒ 
        /// </summary>
        private int bottomMargin = 1440;

        /// <summary>
        ///  
        /// </summary>
        private bool landscape = false;

        /// <summary>
        /// Ӹ Ÿ
        /// </summary>
        private int headerDistance = 720;

        /// <summary>
        /// ٴڱ Ÿ
        /// </summary>
        private int footerDistance = 720;

        /// <summary>
        /// Times New Roman  
        /// </summary>
        private bool changeTimesNewRoman = false;

        /// <summary>
        /// Ʈ  
        /// </summary>
        private int defaultRowHeight = 400;

        /// <summary>
        /// HTML Ʈ
        /// </summary>
        private string htmlContent = null;

        /// <summary>
        /// Ʈ  
        /// </summary>
        private bool startContent = false;

        /// <summary>
        /// ū īƮ
        /// </summary>
        private int tokenCount = 0;

        /// <summary>
        ///    
        /// </summary>
        private RTFDocumentFormatInfo paragraphFormat = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region    - FollowingCharacters

        /// <summary>
        ///   
        /// </summary>
        [DefaultValue(null)]
        public string FollowingCharacters
        {
            get
            {
                return this.followingCharacters;
            }
            set
            {
                this.followingCharacters = value;
            }
        }

        #endregion
        #region   - LeadingCharacters

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(null)]
        public string LeadingCharacters
        {
            get
            {
                return this.leadingCharacters;
            }
            set
            {
                this.leadingCharacters = value;
            }
        }

        #endregion
        #region Ʈ ̺ - FontTable

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        public RTFFontTable FontTable
        {
            get
            {
                return this.fontTable;
            }
            set
            {
                this.fontTable = value;
            }
        }

        #endregion
        #region  ̺ - ColorTable

        /// <summary>
        ///  ̺
        /// </summary>
        public RTFColorTable ColorTable
        {
            get
            {
                return this.colorTable;
            }
            set
            {
                this.colorTable = value;
            }
        }

        #endregion
        #region Ʈ ̺ - ListTable

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        public RTFListTable ListTable
        {
            get
            {
                return this.listTable;
            }
            set
            {
                this.listTable = value;
            }
        }

        #endregion
        #region Ʈ ̵ ̺ - ListOverrideTable

        /// <summary>
        /// Ʈ ̵ ̺
        /// </summary>
        public RTFListOverrideTable ListOverrideTable
        {
            get
            {
                return this.listOverrideTable;
            }
            set
            {
                this.listOverrideTable = value;
            }
        }

        #endregion
        #region   - DocumentInfo

        /// <summary>
        ///  
        /// </summary>
        public RTFDocumentInfo DocumentInfo
        {
            get
            {
                return this.documentInfo;
            }
            set
            {
                this.documentInfo = value;
            }
        }

        #endregion
        #region ʷ - Generator

        /// <summary>
        /// ʷ
        /// </summary>
        [DefaultValue(null)]
        public string Generator
        {
            get
            {
                return this.generator;
            }
            set
            {
                this.generator = value;
            }
        }

        #endregion
        #region  ʺ - PaperWidth

        /// <summary>
        ///  ʺ
        /// </summary>
        [DefaultValue(12240)]
        public int PaperWidth
        {
            get
            {
                return this.paperWidth; 
            }
            set
            {
                this.paperWidth = value;
            }
        }

        #endregion
        #region   - PaperHeight

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(15840)]
        public int PaperHeight
        {
            get
            {
                return this.paperHeight;
            }
            set
            {
                this.paperHeight = value;
            }
        }

        #endregion
        #region   - LeftMargin

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(1800)]
        public int LeftMargin
        {
            get
            {
                return this.leftMargin;
            }
            set
            {
                this.leftMargin = value;
            }
        }

        #endregion
        #region   - TopMargin

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(1440)]
        public int TopMargin
        {
            get
            {
                return this.topMargin;
            }
            set
            {
                this.topMargin = value;
            }
        }

        #endregion
        #region   - RightMargin

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(1800)]
        public int RightMargin
        {
            get
            {
                return this.rightMargin;
            }
            set
            {
                this.rightMargin = value;
            }
        }

        #endregion
        #region Ʒ  - BottomMargin

        /// <summary>
        /// Ʒ 
        /// </summary>
        [DefaultValue(1440)]
        public int BottomMargin
        {
            get
            {
                return this.bottomMargin;
            }
            set
            {
                this.bottomMargin = value;
            }
        }

        #endregion
        #region   - Landscape

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(false)]
        public bool Landscape
        {
            get
            {
                return this.landscape;
            }
            set
            {
                this.landscape = value;
            }
        }

        #endregion
        #region Ӹ Ÿ - HeaderDistance

        /// <summary>
        /// Ӹ Ÿ
        /// </summary>
        [DefaultValue(720)]
        public int HeaderDistance
        {
            get
            {
                return this.headerDistance; 
            }
            set
            {
                this.headerDistance = value;
            }
        }

        #endregion
        #region ٴڱ Ÿ - FooterDistance

        /// <summary>
        /// ٴڱ Ÿ
        /// </summary>
        [DefaultValue(720)]
        public int FooterDistance
        {
            get
            {
                return this.footerDistance;
            }
            set
            {
                this.footerDistance = value;
            }
        }

        #endregion
        #region Ŭ̾Ʈ  ʺ - ClientAreaWidth

        /// <summary>
        /// Ŭ̾Ʈ  ʺ
        /// </summary>
        [Browsable(false)]
        public int ClientAreaWidth
        {
            get
            {
                if(this.landscape)
                {
                    return this.paperHeight - this.leftMargin - this.rightMargin;
                }
                else
                {
                    return this.paperWidth - this.leftMargin - this.rightMargin;
                }
            }
        }

        #endregion
        #region Times New Roman   - ChangeTimesNewRoman

        /// <summary>
        /// Times New Roman  
        /// </summary>
        [DefaultValue(true)]
        public bool ChangeTimesNewRoman
        {
            get
            {
                return this.changeTimesNewRoman;
            }
            set
            {
                this.changeTimesNewRoman = value;
            }
        }

        #endregion
        #region Ʈ   - DefaultRowHeight

        /// <summary>
        /// Ʈ  
        /// </summary>
        public int DefaultRowHeight
        {
            get
            {
                return this.defaultRowHeight;
            }
            set
            {
                this.defaultRowHeight = value;
            }
        }

        #endregion
        #region HTML Ʈ - HTMLContent

        /// <summary>
        /// HTML Ʈ
        /// </summary>
        public string HTMLContent
        {
            get
            {
                return this.htmlContent;
            }
            set
            {
                this.htmlContent = value;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region  ڵ - RuntimeEncoding

        /// <summary>
        ///  ڵ
        /// </summary>
        internal Encoding RuntimeEncoding
        {
            get
            {
                if(this.fontChartSetEncoding != null)
                {
                    return this.fontChartSetEncoding;
                }

                if(this.associateFontChartSetEncoding != null)
                {
                    return this.associateFontChartSetEncoding;
                }

                return this.defaultEncoding;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDOMDocument()

        /// <summary>
        /// 
        /// </summary>
        public RTFDOMDocument()
        {
            OwnerDocument = this;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region εϱ - Load(stream)

        /// <summary>
        /// εϱ
        /// </summary>
        /// <param name="stream">Ʈ</param>
        public void Load(Stream stream)
        {
            this.htmlContent = null;

            ElementList.Clear();

            this.startContent = false;

            RTFReader reader = new RTFReader(stream);

            RTFDocumentFormatInfo format = new RTFDocumentFormatInfo();

            this.paragraphFormat = null;

            Load(reader, format);

            CombinTable(this);

            FixElements(this);
        }

        #endregion
        #region εϱ - Load(filePath)

        /// <summary>
        /// εϱ
        /// </summary>
        /// <param name="filePath"> </param>
        public void Load(string filePath)
        {
            using(FileStream stream = new FileStream(filePath, FileMode.Open, FileAccess.Read))
            {
                Load(stream);
            }
        }

        #endregion
        #region εϱ - Load(textReader)

        /// <summary>
        /// εϱ
        /// </summary>
        /// <param name="textReader">ؽƮ </param>
        public void Load(TextReader textReader)
        {
            this.htmlContent = null;

            ElementList.Clear();

            this.startContent = false;

            RTFReader rtfReader = new RTFReader(textReader);

            RTFDocumentFormatInfo format = new RTFDocumentFormatInfo();

            this.paragraphFormat = null;

            Load(rtfReader, format);

            CombinTable(this);

            FixElements(this);
        }

        #endregion
        #region RTF ؽƮ εϱ - LoadRTFText(rtf)

        /// <summary>
        /// RTF ؽƮ εϱ
        /// </summary>
        /// <param name="rtf">RTF</param>
        public void LoadRTFText(string rtf)
        {
            StringReader stringReader = new StringReader(rtf);

            this.htmlContent = null;

            ElementList.Clear();

            this.startContent = false;

            RTFReader rtfReader = new RTFReader(stringReader);

            RTFDocumentFormatInfo format = new RTFDocumentFormatInfo();

            this.paragraphFormat = null;

            Load(rtfReader, format);

            CombinTable(this);

            FixElements(this);
        }

        #endregion
        #region  Ʈ ϱ - GetLastElement()

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <returns> Ʈ</returns>
        public RTFDOMElement GetLastElement()
        {
            RTFDOMElement[] lastElementArray = GetLastElementArray(true);

            return lastElementArray[lastElementArray.Length - 1];
        }

        #endregion
        #region  Ʈ ϱ - GetLastElement(elementType)

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <param name="elementType">Ʈ Ÿ</param>
        /// <returns> Ʈ</returns>
        public RTFDOMElement GetLastElement(Type elementType)
        {
            RTFDOMElement[] lastElementArray = GetLastElementArray(true);

            for(int i = lastElementArray.Length - 1; i >= 0; i--)
            {
                if(elementType.IsInstanceOfType(lastElementArray[i]))
                {
                    return lastElementArray[i];
                }
            }

            return null;
        }

        #endregion
        #region  Ʈ ϱ - GetLastElement(elementType, lockStatus)

        /// <summary>
        ///  Ʈ ϱ
        /// </summary>
        /// <param name="elementType">Ʈ Ÿ</param>
        /// <param name="lockStatus">  </param>
        /// <returns> Ʈ</returns>
        public RTFDOMElement GetLastElement(Type elementType, bool lockStatus)
        {
            RTFDOMElement[] laseElementArray = GetLastElementArray(true);

            for(int i = laseElementArray.Length - 1; i >= 0; i--)
            {
                if(elementType.IsInstanceOfType(laseElementArray[i]))
                {
                    if(laseElementArray[i].Locked == lockStatus)
                    {
                        return laseElementArray[i];
                    }
                }
            }

            return null;
        }

        #endregion
        #region DOM ڿ ϱ - GetDOMString()

        /// <summary>
        /// DOM ڿ ϱ
        /// </summary>
        /// <returns>DOM ڿ</returns>
        public override string GetDOMString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.Append(ToString());

            stringBuilder.Append(Environment.NewLine + "   Info");

            foreach(string item in this.documentInfo.ItemArray)
            {
                stringBuilder.Append(Environment.NewLine + "      " + item);
            }

            stringBuilder.Append(Environment.NewLine + "   ColorTable(" + this.colorTable.Count + ")");

            for(int i = 0; i < this.colorTable.Count; i ++)
            {
                Color color = this.colorTable[i];

                stringBuilder.Append(Environment.NewLine + "      " + i + ":" + color.R + " " + color.G + " " + color.B);
            }

            stringBuilder.Append(Environment.NewLine + "   FontTable(" + this.fontTable.Count + ")");

            foreach(RTFFont font in this.fontTable)
            {
                stringBuilder.Append(Environment.NewLine + "      " + font.ToString());
            }

            if(this.listTable.Count > 0)
            {
                stringBuilder.Append(Environment.NewLine + "   ListTable(" + this.listTable.Count + ")");

                foreach(RTFList list in this.listTable)
                {
                    stringBuilder.Append(Environment.NewLine + "      " + list.ToString());
                }
            }

            if(this.ListOverrideTable.Count > 0)
            {
                stringBuilder.Append(Environment.NewLine + "   ListOverrideTable(" + ListOverrideTable.Count + ")");

                foreach(RTFListOverride list in ListOverrideTable)
                {
                    stringBuilder.Append(Environment.NewLine + "      " + list.ToString());
                }
            }

            stringBuilder.Append(Environment.NewLine + "   -----------------------");

            if(string.IsNullOrEmpty(this.HTMLContent) == false)
            {
                stringBuilder.Append(Environment.NewLine + "   HTMLContent:" + HTMLContent);
                stringBuilder.Append(Environment.NewLine + "   -----------------------");
            }

            GetDOMString(ElementList, stringBuilder, 1);

            return stringBuilder.ToString();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  ̺Ʈ ߻Ű - FireProgressEvent(maximumValue, value, message)

        /// <summary>
        ///  ̺Ʈ ߻Ű
        /// </summary>
        /// <param name="maximumValue">ִ </param>
        /// <param name="value"></param>
        /// <param name="message">޽</param>
        /// <returns>ó </returns>
        protected bool FireProgressEvent(int maximumValue, int value, string message)
        {
            if(Progress != null)
            {
                ProgressEventArgs e = new ProgressEventArgs(maximumValue, value, message);

                Progress(this, e);

                return e.Cancel;
            }

            return false;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Ʈ ϱ - FixElements(parentElement)

        /// <summary>
        /// Ʈ ϱ
        /// </summary>
        /// <param name="parentElement">θ Ʈ</param>
        private void FixElements(RTFDOMElement parentElement)
        {
            ArrayList arrayList = new ArrayList();

            foreach(RTFDOMElement element in parentElement.ElementList)
            {
                if(element is RTFDOMParagraph)
                {
                    RTFDOMParagraph paragraph = (RTFDOMParagraph)element;

                    if(paragraph.Format.PageBreak)
                    {
                        paragraph.Format.PageBreak = false;

                        arrayList.Add(new RTFDOMPageBreak());
                    }
                }

                if(element is RTFDOMText)
                {
                    if(arrayList.Count > 0 && arrayList[arrayList.Count - 1] is RTFDOMText)
                    {
                        RTFDOMText lastText = (RTFDOMText)arrayList[arrayList.Count - 1];

                        RTFDOMText text = (RTFDOMText)element;

                        if(lastText.Text.Length == 0 || text.Text.Length == 0)
                        {
                            if(lastText.Text.Length == 0)
                            {
                                lastText.Format = text.Format.Clone();
                            }

                            lastText.Text = lastText.Text + text.Text;
                        }
                        else
                        {
                            if(lastText.Format.EqualsSettings(text.Format))
                            {
                                lastText.Text = lastText.Text + text.Text;
                            }
                            else
                            {
                                arrayList.Add(text);
                            }
                        }
                    }
                    else
                    {
                        arrayList.Add(element);
                    }
                }
                else
                {
                    arrayList.Add(element);
                }
            }

            parentElement.ElementList.Clear();

            parentElement.Locked = false;

            foreach(RTFDOMElement element in arrayList)
            {
                parentElement.AppendChild(element);
            }

            foreach(RTFDOMElement element in parentElement.ElementList.ToArray())
            {
                if(element is RTFDOMTable)
                {
                    UpdateTableCells((RTFDOMTable)element, true);
                }
            }

            foreach(RTFDOMElement element in parentElement.ElementList)
            {
                FixElements(element);
            }
        }

        #endregion
        #region  Ʈ 迭 ϱ - GetLastElementArray(checkLockState)

        /// <summary>
        ///  Ʈ 迭 ϱ
        /// </summary>
        /// <param name="checkLockState">  üũ </param>
        /// <returns>Ʈ 迭</returns>
        private RTFDOMElement[] GetLastElementArray(bool checkLockState)
        {
            List<RTFDOMElement> targetList = new List<RTFDOMElement>();

            RTFDOMElement element = this;

            while(element != null)
            {
                if(checkLockState)
                {
                    if(element.Locked)
                    {
                        break;
                    }
                }

                targetList.Add(element);

                element = element.ElementList.LastElement;
            }

            if(checkLockState)
            {
                for(int i = targetList.Count - 1; i >= 0; i--)
                {
                    if(targetList[i].Locked)
                    {
                        targetList.RemoveAt(i);
                    }
                }
            }

            return targetList.ToArray();
        }

        #endregion
        #region  Ϸϱ - CompleteParagraph()

        /// <summary>
        ///  Ϸϱ
        /// </summary>
        private void CompleteParagraph()
        {
            RTFDOMElement lastElement = GetLastElement();

            while(lastElement != null)
            {
                if(lastElement is RTFDOMParagraph)
                {
                    RTFDOMParagraph paragraph = (RTFDOMParagraph)lastElement;

                    paragraph.Locked = true;

                    if(this.paragraphFormat != null)
                    {
                        paragraph.Format = this.paragraphFormat;

                        this.paragraphFormat = this.paragraphFormat.Clone();
                    }
                    else
                    {
                        this.paragraphFormat = new RTFDocumentFormatInfo();
                    }

                    break;
                }

                lastElement = lastElement.ParentElement;
            }
        }

        #endregion
        #region Ʈ Ʈ ߰ϱ - AddContentElement(newElement)

        /// <summary>
        /// Ʈ Ʈ ߰ϱ
        /// </summary>
        /// <param name="newElement">ű Ʈ</param>
        private void AddContentElement(RTFDOMElement newElement)
        {
            RTFDOMElement[] lastElementArray = GetLastElementArray(true);

            RTFDOMElement lastElement = null;

            if(lastElementArray.Length > 0)
            {
                lastElement = lastElementArray[lastElementArray.Length - 1];
            }

            if(lastElement is RTFDOMDocument || lastElement is RTFDOMHeader || lastElement is RTFDOMFooter)
            {
                if
                (
                    newElement is RTFDOMText   ||
                    newElement is RTFDOMImage  ||
                    newElement is RTFDOMObject ||
                    newElement is RTFDOMShape  ||
                    newElement is RTFDOMShapeGroup
                )
                {
                    RTFDOMParagraph paragraph = new RTFDOMParagraph();

                    if(lastElement.ElementList.Count > 0)
                    {
                        paragraph.isTemplateGenerated = true;
                    }

                    if(this.paragraphFormat != null)
                    {
                        paragraph.Format = this.paragraphFormat;
                    }

                    lastElement.AppendChild(paragraph);

                    paragraph.ElementList.Add(newElement);

                    return;
                }
            }

            RTFDOMElement element1 = lastElementArray[lastElementArray.Length - 1];

            if(newElement != null && newElement.NativeLevel > 0)
            {
                for(int i = lastElementArray.Length - 1; i >= 0; i--)
                {
                    if(lastElementArray[i].NativeLevel == newElement.NativeLevel)
                    {
                        for(int j = i; j < lastElementArray.Length; j++)
                        {
                            RTFDOMElement element2 = lastElementArray[j];

                            if
                            (
                                newElement is RTFDOMText       ||
                                newElement is RTFDOMImage      ||
                                newElement is RTFDOMObject     ||
                                newElement is RTFDOMShape      ||
                                newElement is RTFDOMShapeGroup ||
                                newElement is RTFDOMField      ||
                                newElement is RTFDOMBookmark   ||
                                newElement is RTFDOMLineBreak
                            )
                            {
                                if(newElement.NativeLevel == element2.NativeLevel)
                                {
                                    if
                                    (
                                        element2 is RTFDOMTableRow  ||
                                        element2 is RTFDOMTableCell ||
                                        element2 is RTFDOMField     ||
                                        element2 is RTFDOMParagraph
                                    )
                                    {
                                        continue;
                                    }
                                }
                            }

                            lastElementArray[j].Locked = true;
                        }

                        break;
                    }
                }
            }
            
            for(int i = lastElementArray.Length - 1; i >= 0; i--)
            {
                if(lastElementArray[i].Locked == false)
                {
                    element1 = lastElementArray[i];

                    if(element1 is RTFDOMImage)
                    {
                        element1.Locked = true;
                    }
                    else
                    {
                        break;
                    }
                }
            }

            if(element1 is RTFDOMTableRow)
            {
                RTFDOMTableCell cell = new RTFDOMTableCell();

                cell.NativeLevel = element1.NativeLevel;

                element1.AppendChild(cell);

                if(newElement is RTFDOMTableRow)
                {
                    cell.ElementList.Add(newElement);
                }
                else
                {
                    RTFDOMParagraph cellParagraph = new RTFDOMParagraph();

                    cellParagraph.Format      = this.paragraphFormat.Clone();
                    cellParagraph.NativeLevel = cell.NativeLevel;

                    cell.AppendChild(cellParagraph);

                    if(newElement != null)
                    {
                        cellParagraph.AppendChild(newElement);
                    }
                }
            }
            else
            {
                if(newElement != null)
                {
                    if(element1 is RTFDOMParagraph && (newElement is RTFDOMParagraph || newElement is RTFDOMTableRow))
                    {
                        element1.Locked = true;

                        element1.ParentElement.AppendChild(newElement);
                    }
                    else
                    {
                        element1.AppendChild(newElement);
                    }
                }
            }
        }

        #endregion
        #region Ʈ 迭 ϱ - GetByteArray(hexadecimal)

        /// <summary>
        /// Ʈ 迭 ϱ
        /// </summary>
        /// <param name="hexadecimal">16 ڿ</param>
        /// <returns>Ʈ 迭</returns>
        private byte[] GetByteArray(string hexadecimal)
        {
            string characterList = "0123456789abcdef";

            int index          = 0;
            int value          = 0;
            int characterCount = 0;

            ByteBuffer buffer = new ByteBuffer();

            for(int i = 0; i < hexadecimal.Length; i++)
            {
                char character = hexadecimal[i];

                character = char.ToLower(character);

                index = characterList.IndexOf(character);

                if(index >= 0)
                {
                    characterCount++;

                    value = value * 16 + index;

                    if(characterCount > 0 && (characterCount % 2) == 0)
                    {
                        buffer.Add((byte)value);

                        value = 0;
                    }
                }
            }

            return buffer.ToArray();
        }

        #endregion
        #region ̺ ϱ - CombinTable(parentElement)

        /// <summary>
        /// ̺ ϱ
        /// </summary>
        /// <param name="parentElement">θ Ʈ</param>
        private void CombinTable(RTFDOMElement parentElement)
        {
            ArrayList      targetList   = new ArrayList();
            ArrayList      rowList      = new ArrayList();
            int            lastRowWidth = -1;
            RTFDOMTableRow lastRow      = null;

            foreach(RTFDOMElement element in parentElement.ElementList)
            {
                if(element is RTFDOMTableRow)
                {
                    RTFDOMTableRow row = (RTFDOMTableRow)element;

                    row.Locked = false;

                    ArrayList cellSettingList = row.CellSettingList;

                    if(cellSettingList.Count == 0)
                    {
                        if(lastRow != null && lastRow.CellSettingList.Count == row.ElementList.Count)
                        {
                            cellSettingList = lastRow.CellSettingList;
                        }
                    }

                    if(cellSettingList.Count == row.ElementList.Count)
                    {
                        for(int i = 0; i < row.ElementList.Count; i++)
                        {
                            row.ElementList[i].AttributeList = (RTFAttributeList)cellSettingList[i];
                        }
                    }

                    bool isLastRow = row.HasAttribute(RTFConstant.LASTROW);

                    if(isLastRow == false)
                    {
                        int index = parentElement.ElementList.GetIndex(element);

                        if(index == parentElement.ElementList.Count - 1)
                        {
                            isLastRow = true;
                        }
                        else
                        {
                            RTFDOMElement childElement = parentElement.ElementList[index + 1];

                            if(!(childElement is RTFDOMTableRow))
                            {
                                isLastRow = true;
                            }
                        }
                    }

                    if(isLastRow)
                    {
                        rowList.Add(row);

                        targetList.Add(CreateTable(rowList));

                        lastRowWidth = -1;
                    }
                    else
                    {
                        int width = 0;

                        if(row.HasAttribute(RTFConstant.TRWWIDTH))
                        {
                            width = row.AttributeList[RTFConstant.TRWWIDTH];

                            if(row.HasAttribute(RTFConstant.TRWWIDTHA))
                            {
                                width = width - row.AttributeList[RTFConstant.TRWWIDTHA];
                            }
                        }
                        else
                        {
                            foreach(RTFDOMTableCell cell in row.ElementList)
                            {
                                if(cell.HasAttribute(RTFConstant.CELLX))
                                {
                                    width = Math.Max(width, cell.AttributeList[RTFConstant.CELLX]);
                                }
                            }
                        }
                        if(lastRowWidth > 0 && lastRowWidth != width)
                        {
                            if(rowList.Count > 0)
                            {
                                targetList.Add(CreateTable(rowList));
                            }
                        }

                        lastRowWidth = width;

                        rowList.Add(row);
                    }

                    lastRow = row;
                }
                else if(element is RTFDOMTableCell)
                {
                    lastRow = null;

                    CombinTable(element);

                    if(rowList.Count > 0)
                    {
                        targetList.Add(CreateTable(rowList));
                    }

                    targetList.Add(element);

                    lastRowWidth = -1;
                }
                else
                {
                    lastRow = null;

                    CombinTable(element);

                    if(rowList.Count > 0)
                    {
                        targetList.Add(CreateTable(rowList));
                    }

                    targetList.Add(element);

                    lastRowWidth = -1;
                }
            }

            if(rowList.Count > 0)
            {
                targetList.Add(CreateTable(rowList));
            }

            parentElement.Locked = false;

            parentElement.ElementList.Clear();

            foreach(RTFDOMElement element in targetList)
            {
                parentElement.AppendChild(element);
            }
        }

        #endregion
        #region ̺ ϱ - CreateTable(rowList)

        /// <summary>
        /// ̺ ϱ
        /// </summary>
        /// <param name="rowList"> Ʈ</param>
        /// <returns>̺</returns>
        private RTFDOMTable CreateTable(ArrayList rowList)
        {
            if(rowList.Count > 0)
            {
                RTFDOMTable table = new RTFDOMTable();

                int index = 0;

                foreach(RTFDOMTableRow row in rowList)
                {
                    row.RowIndex = index;

                    index++;

                    table.AppendChild(row);
                }

                rowList.Clear();

                foreach(RTFDOMTableRow row in table.ElementList)
                {
                    foreach(RTFDOMTableCell cell in row.ElementList)
                    {
                        CombinTable(cell);
                    }
                }

                return table;
            }
            else
            {
                throw new ArgumentException("rowList");
            }
        }

        #endregion
        #region ̺  Ʈϱ - UpdateTableCells(table, fixTableCellSize)

        /// <summary>
        /// ̺  Ʈϱ
        /// </summary>
        /// <param name="table">̺</param>
        /// <param name="fixTableCellSize">̺  ũ  </param>
        private void UpdateTableCells(RTFDOMTable table, bool fixTableCellSize)
        {
            int       columnCount = 0;
            bool      merge       = false;
            ArrayList rightList   = new ArrayList();
            int       tableLeft   = 0;

            for(int i = table.ElementList.Count - 1; i >= 0; i--)
            {
                RTFDOMTableRow row = (RTFDOMTableRow)table.ElementList[i];

                if(row.ElementList.Count == 0)
                {
                    table.ElementList.RemoveAt(i);
                }
            }

            foreach(RTFDOMTableRow row in table.ElementList)
            {
                int lastCellX = 0;

                columnCount = Math.Max(columnCount, row.ElementList.Count);

                if(row.HasAttribute(RTFConstant.IROW))
                {
                    row.RowIndex = row.AttributeList[RTFConstant.IROW];
                }

                row.IsLastRow = row.HasAttribute(RTFConstant.LASTROW);
                row.Header    = row.HasAttribute(RTFConstant.TRHDR);

                if(row.HasAttribute(RTFConstant.TRRH))
                {
                    row.Height = row.AttributeList[RTFConstant.TRRH];

                    if(row.Height == 0)
                    {
                        row.Height = this.DefaultRowHeight;
                    }
                    else if(row.Height < 0)
                    {
                        row.Height = -row.Height;
                    }
                }
                else
                {
                    row.Height = this.DefaultRowHeight;
                }

                if(row.HasAttribute(RTFConstant.TRPADDL))
                {
                    row.PaddingLeft = row.AttributeList[RTFConstant.TRPADDL];
                }
                else
                {
                    row.PaddingLeft = int.MinValue;
                }

                if(row.HasAttribute(RTFConstant.TRPADDT))
                {
                    row.PaddingTop = row.AttributeList[RTFConstant.TRPADDT];
                }
                else
                {
                    row.PaddingTop = int.MinValue;
                }

                if(row.HasAttribute(RTFConstant.TRPADDR))
                {
                    row.PaddingRight = row.AttributeList[RTFConstant.TRPADDR];
                }
                else
                {
                    row.PaddingRight = int.MinValue;
                }

                if(row.HasAttribute(RTFConstant.TRPADDB))
                {
                    row.PaddingBottom = row.AttributeList[RTFConstant.TRPADDB];
                }
                else
                {
                    row.PaddingBottom = int.MinValue;
                }

                if(row.HasAttribute(RTFConstant.TRLEFT))
                {
                    tableLeft = row.AttributeList[RTFConstant.TRLEFT];
                }

                if(row.HasAttribute(RTFConstant.TRCBPAT))
                {
                    row.Format.BackgroundColor = this.ColorTable.GetColor(row.AttributeList[RTFConstant.TRCBPAT], Color.Transparent);
                }

                int widthCount = 0;

                foreach(RTFDOMTableCell cell in row.ElementList)
                {
                    if(cell.HasAttribute(RTFConstant.CLVMGF))
                    {
                        merge = true;
                    }

                    if(cell.HasAttribute(RTFConstant.CLVMRG))
                    {
                        merge = true;
                    }

                    if(cell.HasAttribute(RTFConstant.CLPADL))
                    {
                        cell.PaddingLeft = cell.AttributeList[RTFConstant.CLPADL];
                    }
                    else
                    {
                        cell.PaddingLeft = int.MinValue;
                    }

                    if(cell.HasAttribute(RTFConstant.CLPADR))
                    {
                        cell.PaddingRight = cell.AttributeList[RTFConstant.CLPADR];
                    }
                    else
                    {
                        cell.PaddingRight = int.MinValue;
                    }

                    if(cell.HasAttribute(RTFConstant.CLPADT))
                    {
                        cell.PaddingTop = cell.AttributeList[RTFConstant.CLPADT];
                    }
                    else
                    {
                        cell.PaddingTop = int.MinValue;
                    }

                    if(cell.HasAttribute(RTFConstant.CLPADB))
                    {
                        cell.PaddingBottom = cell.AttributeList[RTFConstant.CLPADB];
                    }
                    else
                    {
                        cell.PaddingBottom = int.MinValue;
                    }

                    cell.Format.LeftBorder   = cell.HasAttribute(RTFConstant.CLBRDRL);
                    cell.Format.TopBorder    = cell.HasAttribute(RTFConstant.CLBRDRT);
                    cell.Format.RightBorder  = cell.HasAttribute(RTFConstant.CLBRDRR);
                    cell.Format.BottomBorder = cell.HasAttribute(RTFConstant.CLBRDRB);

                    if(cell.HasAttribute(RTFConstant.BRDRCF))
                    {
                        cell.Format.BorderColor = this.ColorTable.GetColor(cell.GetAttributeValue(RTFConstant.BRDRCF, 1), Color.Black);
                    }

                    for(int i = cell.AttributeList.Count - 1; i >= 0; i--)
                    {
                        string name3 = cell.AttributeList.GetItem(i).Name;

                        if(name3 == RTFConstant.BRDRTBL || name3 == RTFConstant.BRDRNONE || name3 == RTFConstant.BRDRNIL)
                        {
                            for(int j = i - 1; j >= 0; j--)
                            {
                                string name2 = cell.AttributeList.GetItem(j).Name;

                                if(name2 == RTFConstant.CLBRDRL)
                                {
                                    cell.Format.LeftBorder = false;

                                    break;
                                }
                                else if(name2 == RTFConstant.CLBRDRT)
                                {
                                    cell.Format.TopBorder = false;

                                    break;
                                }
                                else if(name2 == RTFConstant.CLBRDRR)
                                {
                                    cell.Format.RightBorder = false;

                                    break;
                                }
                                else if(name2 == RTFConstant.CLBRDRB)
                                {
                                    cell.Format.BottomBorder = false;

                                    break;
                                }
                            }
                        }
                    }

                    if(cell.HasAttribute(RTFConstant.CLVERTALT))
                    {
                        cell.VerticalAlignment = RTFVerticalAlignment.Top;
                    }
                    else if(cell.HasAttribute(RTFConstant.CLVERTALC))
                    {
                        cell.VerticalAlignment = RTFVerticalAlignment.Middle;
                    }
                    else if(cell.HasAttribute(RTFConstant.CLVERTALB))
                    {
                        cell.VerticalAlignment = RTFVerticalAlignment.Bottom;
                    }

                    if(cell.HasAttribute(RTFConstant.CLCBPAT))
                    {
                        cell.Format.BackgroundColor = this.ColorTable.GetColor(cell.AttributeList[RTFConstant.CLCBPAT], Color.Transparent);
                    }
                    else
                    {
                        cell.Format.BackgroundColor = Color.Transparent;
                    }

                    if(cell.HasAttribute(RTFConstant.CLCFPAT))
                    {
                        cell.Format.BorderColor = this.ColorTable.GetColor(cell.AttributeList[RTFConstant.CLCFPAT], Color.Black);
                    }

                    int cellWidth = 2763;

                    if(cell.HasAttribute(RTFConstant.CELLX))
                    {
                        cellWidth = cell.AttributeList[RTFConstant.CELLX] - lastCellX;

                        if(cellWidth < 100)
                        {
                            cellWidth = 100;
                        }
                    }

                    int right = lastCellX + cellWidth;

                    for(int i = 0; i < rightList.Count; i++)
                    {
                        if(Math.Abs(right - (int)rightList[i]) < 45)
                        {
                            right = (int)rightList[i];

                            cellWidth = right - lastCellX;

                            break;
                        }
                    }

                    cell.Left  = lastCellX;
                    cell.Width = cellWidth;

                    widthCount += cellWidth;

                    if(rightList.Contains(right) == false)
                    {
                        rightList.Add(right);
                    }

                    lastCellX = lastCellX + cellWidth;
                }

                row.Width = widthCount;
            }

            if(rightList.Count == 0)
            {
                int temporaryColumnCount = 1;

                foreach(RTFDOMTableRow row in table.ElementList)
                {
                    temporaryColumnCount = Math.Max(temporaryColumnCount, row.ElementList.Count);
                }

                int width = (int)(ClientAreaWidth / temporaryColumnCount);

                for(int iCount = 0; iCount < temporaryColumnCount; iCount++)
                {
                    rightList.Add(iCount * width + width);
                }
            }

            rightList.Add(0);

            rightList.Sort();

            for(int i = 1; i < rightList.Count; i++)
            {
                RTFDomTableColumn column = new RTFDomTableColumn();

                column.Width = (int)rightList[i] - (int)rightList[i - 1];

                table.ColumnList.Add(column);
            }

            for(int y = 1; y < table.ElementList.Count; y++)
            {
                RTFDOMTableRow row = (RTFDOMTableRow)table.ElementList[y];

                for(int x = 0; x < row.ElementList.Count; x++)
                {
                    RTFDOMTableCell cell = (RTFDOMTableCell)row.ElementList[x];

                    if(cell.Width == 0)
                    {
                        RTFDOMTableRow previousRow = (RTFDOMTableRow)table.ElementList[y - 1];

                        if(previousRow.ElementList.Count > x)
                        {
                            RTFDOMTableCell preCell = (RTFDOMTableCell)previousRow.ElementList[x];

                            cell.Left  = preCell.Left;
                            cell.Width = preCell.Width;

                            CopyStyleAttribute(cell, preCell.AttributeList);
                        }
                    }
                }
            }

            if(merge == false)
            {
                foreach(RTFDOMTableRow row in table.ElementList)
                {
                    if(row.ElementList.Count < table.ColumnList.Count)
                    {
                        merge = true;

                        break;
                    }
                }
            }

            if(merge)
            {
                foreach(RTFDOMTableRow row in table.ElementList)
                {
                    if(row.ElementList.Count != table.ColumnList.Count)
                    {
                        RTFDOMElement[] cellArray = row.ElementList.ToArray();

                        foreach(RTFDOMTableCell cell in cellArray)
                        {
                            int index1     = rightList.IndexOf(cell.Left);
                            int index2     = rightList.IndexOf(cell.Left + cell.Width);
                            int columnSpan = index2 - index1;

                            bool verticalMerge = cell.HasAttribute(RTFConstant.CLVMRG);

                            if(verticalMerge == false)
                            {
                                cell.ColumnSpan = columnSpan;
                            }

                            if(row.ElementList.LastElement == cell)
                            {
                                cell.ColumnSpan = table.ColumnList.Count - row.ElementList.Count + 1;

                                columnSpan = cell.ColumnSpan;
                            }

                            for(int i = 0; i < columnSpan - 1; i++)
                            {
                                RTFDOMTableCell newCell = new RTFDOMTableCell();

                                newCell.AttributeList = cell.AttributeList.Clone();

                                row.ElementList.Insert(row.ElementList.GetIndex(cell) + 1, newCell);

                                if(verticalMerge)
                                {
                                    newCell.AttributeList[RTFConstant.CLVMRG] = 1;

                                    newCell.OverrideCell = cell;
                                }
                            }
                        }

                        if(row.ElementList.Count != table.ColumnList.Count)
                        {
                            RTFDOMTableCell lastCell = (RTFDOMTableCell)row.ElementList.LastElement;

                            for(int i = row.ElementList.Count; i < rightList.Count; i++)
                            {
                                RTFDOMTableCell newCell = new RTFDOMTableCell();

                                CopyStyleAttribute(newCell, lastCell.AttributeList);

                                row.ElementList.Add(newCell);
                            }
                        }
                    }
                }

                foreach(RTFDOMTableRow row in table.ElementList)
                {
                    foreach(RTFDOMTableCell cell in row.ElementList)
                    {
                        if(cell.HasAttribute(RTFConstant.CLVMGF) == false)
                        {
                            continue;
                        }

                        int x = row.ElementList.GetIndex(cell);

                        for(int y = table.ElementList.GetIndex(row) + 1; y < table.ElementList.Count; y++)
                        {
                            RTFDOMTableRow temporaryRow = (RTFDOMTableRow)table.ElementList[y];

                            RTFDOMTableCell temporaryCell = (RTFDOMTableCell)temporaryRow.ElementList[x];

                            if(temporaryCell.HasAttribute(RTFConstant.CLVMRG))
                            {
                                if(temporaryCell.OverrideCell != null)
                                {
                                    break;
                                }

                                cell.RowSpan++;

                                temporaryCell.OverrideCell = cell;
                            }
                            else
                            {
                                break;
                            }
                        }
                    }
                }

                foreach(RTFDOMTableRow row in table.ElementList)
                {
                    foreach(RTFDOMTableCell cell in row.ElementList)
                    {
                        if(cell.RowSpan > 1 || cell.ColumnSpan > 1)
                        {
                            for(int y = 1; y <= cell.RowSpan; y++)
                            {
                                for(int x = 1; x <= cell.ColumnSpan; x++)
                                {
                                    int rowIndex    = table.ElementList.GetIndex(row) + y - 1;
                                    int columnIndex = row.ElementList.GetIndex(cell) + x - 1;

                                    RTFDOMTableCell temporaryCell = (RTFDOMTableCell)table.ElementList[rowIndex].ElementList[columnIndex];

                                    if(cell != temporaryCell)
                                    {
                                        temporaryCell.OverrideCell = cell;
                                    }
                                }
                            }
                        }
                    }
                }
            }

            if(fixTableCellSize)
            {
                if(table.ColumnList.Count > 0)
                {
                    ((RTFDomTableColumn)table.ColumnList[0]).Width -= tableLeft;
                }
            }
        }

        #endregion
        #region Ÿ Ư ϱ - CopyStyleAttribute(cell, sourceAttributeList)

        /// <summary>
        /// Ÿ Ư ϱ
        /// </summary>
        /// <param name="cell">̺ </param>
        /// <param name="sourceAttributeList">ҽ Ư Ʈ</param>
        private void CopyStyleAttribute(RTFDOMTableCell cell, RTFAttributeList sourceAttributeList)
        {
            RTFAttributeList targetAttributeList = sourceAttributeList.Clone();

            targetAttributeList.Remove(RTFConstant.CLVMGF);
            targetAttributeList.Remove(RTFConstant.CLVMRG);

            cell.AttributeList = targetAttributeList;
        }

        #endregion
        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            return $"RTFDocument:{this.documentInfo.Title}";
        }

        #endregion
        #region ؽƮ ϱ - ApplyText(textContainer, reader, format)

        /// <summary>
        /// ؽƮ ϱ
        /// </summary>
        /// <param name="textContainer">ؽƮ ̳</param>
        /// <param name="reader"></param>
        /// <param name="format">  </param>
        /// <returns>ó </returns>
        private bool ApplyText(RTFTextContainer textContainer, RTFReader reader, RTFDocumentFormatInfo format)
        {
            if(textContainer.HasContent)
            {
                string textContainerText = textContainer.Text;

                textContainer.Clear();

                RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                if(image != null && image.Locked == false)
                {
                    image.Data   = GetByteArray(textContainerText);
                    image.Format = format.Clone();
                    image.Width  = (int)(image.DesiredWidth  * image.ScaleX / 100);
                    image.Height = (int)(image.DesiredHeight * image.ScaleY / 100);
                    image.Locked = true;

                    if(reader.CurrentTokenType != RTFTokenType.GroupEnd)
                    {
                        ReadToEndGround(reader);
                    }

                    return true;
                }
                else if(format.ReadText && this.startContent)
                {
                    RTFDOMText text = new RTFDOMText();

                    text.NativeLevel = textContainer.Level;
                    text.Format      = format.Clone();

                    if(text.Format.TextAlignment == RTFTextAlignment.JUSTIFY)
                    {
                        text.Format.TextAlignment = RTFTextAlignment.LEFT;
                    }

                    text.Text = textContainerText;

                    AddContentElement(text);
                }
            }

            return false;
        }

        #endregion
        #region εϱ - Load(reader , parentFormat)

        /// <summary>
        /// εϱ
        /// </summary>
        /// <param name="reader"></param>
        /// <param name="parentFormat">θ   </param>
        private void Load(RTFReader reader , RTFDocumentFormatInfo parentFormat)
        {
            bool forbitPard = false;

            RTFDocumentFormatInfo format = null;

            if(this.paragraphFormat == null)
            {
                this.paragraphFormat = new RTFDocumentFormatInfo();
            }

            if(parentFormat == null)
            {
                format = new RTFDocumentFormatInfo();
            }
            else
            {
                format = parentFormat.Clone();

                format.NativeLevel = parentFormat.NativeLevel + 1;
            }

            RTFTextContainer textContainer = new RTFTextContainer(this);

            int levelBack = reader.Level;

            while(reader.ReadToken() != null)
            {
                if(reader.TokenCount - this.tokenCount > 100)
                {
                    this.tokenCount = reader.TokenCount;

                    FireProgressEvent(reader.ContentLength, reader.ContentPosition, null);
                }

                if(this.startContent)
                {
                    if(textContainer.Accept(reader.CurrentToken, reader))
                    {
                        textContainer.Level = reader.Level;

                        continue;
                    }
                    else if(textContainer.HasContent)
                    {
                        if(ApplyText(textContainer, reader, format))
                        {
                            break;
                        }
                    }
                }

                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    RTFDOMElement[] elementArray = GetLastElementArray(true);

                    for(int i = 0 ; i < elementArray.Length ; i ++)
                    {
                        RTFDOMElement element = elementArray[i];

                        if(element.NativeLevel >= 0 && element.NativeLevel > reader.Level)
                        {
                            for(int j = i ; j < elementArray.Length; j++)
                            {
                                elementArray[j].Locked = true;
                            }

                            break;
                        }
                    }

                    break;
                }

                if(reader.Level < levelBack)
                {
                    break;
                }

                if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                    Load(reader, format);

                    if(reader.Level < levelBack)
                    {
                        break;
                    }
                }

                if
                (
                    reader.CurrentTokenType == RTFTokenType.Control ||
                    reader.CurrentTokenType == RTFTokenType.Keyword ||
                    reader.CurrentTokenType == RTFTokenType.ExtendedKeyword
                )
                {
                    switch(reader.CurrentKeyword)
                    {
                        case "fromhtml" :

                            ReadHTMLContent(reader);

                            return;

                        case RTFConstant.LISTTABLE :

                            ReadListTable(reader);

                            return;

                        case RTFConstant.LISTOVERRIDE :

                            ReadToEndGround(reader);

                            break;

                        case RTFConstant.ANSI :

                            break;

                        case RTFConstant.ANSICPG :

                            this.defaultEncoding = Encoding.GetEncoding(reader.CurrentParameter);

                            break;

                        case RTFConstant.FONTTBL :

                            ReadFontTable(reader);

                            break;

                        case "listoverridetable" :

                            ReadListOverrideTable(reader);

                            break;

                        case "filetbl" :

                            ReadToEndGround(reader);

                            break;

                        case RTFConstant.COLORTBL :

                            ReadColorTable(reader);

                            return;

                        case "stylesheet" :

                            ReadToEndGround(reader);

                            break;

                        case RTFConstant.GENERATOR :

                            Generator = ReadInnerText(reader, true);

                            break;

                        case RTFConstant.INFO :

                            ReadDocumentInfo(reader);

                            return ;

                        case RTFConstant.HEADERY :

                            if(reader.HasCurrentParameter)
                            {
                                HeaderDistance = reader.CurrentParameter;
                            }

                            break;

                        case RTFConstant.FOOTERY :

                            if(reader.HasCurrentParameter)
                            {
                                FooterDistance = reader.CurrentParameter;
                            }

                            break;

                        case RTFConstant.HEADER :
                        {
                            RTFDOMHeader header = new RTFDOMHeader();

                            header.Style = HeaderFooterStyle.ALL_PAGES;

                            AppendChild(header);

                            Load(reader, parentFormat);

                            header.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.HEADERL :
                        {
                            RTFDOMHeader header = new RTFDOMHeader();

                            header.Style = HeaderFooterStyle.LEFT_PAGES;

                            AppendChild(header);

                            Load(reader, parentFormat);

                            header.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.HEADERR :
                        {
                            RTFDOMHeader header = new RTFDOMHeader();

                            header.Style = HeaderFooterStyle.RIGHT_PAGES;

                            AppendChild(header);

                            Load(reader, parentFormat);

                            header.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.HEADERF :
                        {
                            RTFDOMHeader header = new RTFDOMHeader();

                            header.Style = HeaderFooterStyle.FIRST_PAGE;

                            AppendChild(header);

                            Load(reader, parentFormat);

                            header.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.FOOTER :
                        {
                            RTFDOMFooter footer = new RTFDOMFooter();

                            footer.Style = HeaderFooterStyle.ALL_PAGES;

                            AppendChild(footer);

                            Load(reader, parentFormat);

                            footer.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.FOOTERL :
                        {
                            RTFDOMFooter footer = new RTFDOMFooter();

                            footer.Style = HeaderFooterStyle.LEFT_PAGES ;

                            AppendChild(footer);

                            Load(reader, parentFormat);

                            footer.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.FOOTERR :
                        {
                            RTFDOMFooter footer = new RTFDOMFooter();

                            footer.Style = HeaderFooterStyle.RIGHT_PAGES ;

                            AppendChild(footer);

                            Load(reader, parentFormat);

                            footer.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.FOOTERF :
                        {
                            RTFDOMFooter footer = new RTFDOMFooter();

                            footer.Style = HeaderFooterStyle.FIRST_PAGE ;

                            AppendChild(footer);

                            Load(reader, parentFormat);

                            footer.Locked = true;

                            this.paragraphFormat = new RTFDocumentFormatInfo();

                            break;
                        }
                        case RTFConstant.XMLNS :

                            ReadToEndGround(reader);

                            break;

                        case RTFConstant.NONESTTABLES :

                            ReadToEndGround(reader);

                            break;

                        case  RTFConstant.XMLOPEN :

                            break;

                        case RTFConstant.REVTBL :

                            break;

                        case RTFConstant.PAPERW :

                            this.paperWidth = reader.CurrentParameter;

                            break;

                        case RTFConstant.PAPERH :

                            this.paperHeight = reader.CurrentParameter;

                            break;

                        case RTFConstant.MARGL :

                            this.leftMargin = reader.CurrentParameter;

                            break;

                        case RTFConstant.MARGR :

                            this.rightMargin = reader.CurrentParameter;

                            break;

                        case RTFConstant.MARGB :

                            this.bottomMargin = reader.CurrentParameter;

                            break;

                        case RTFConstant.MARGT :

                            this.topMargin = reader.CurrentParameter;

                            break;

                        case RTFConstant.LANDSCAPE :

                            this.landscape = true;

                            break;

                        case RTFConstant.FCHARS :

                            FollowingCharacters = ReadInnerText(reader, true);

                            break;

                        case RTFConstant.LCHARS :

                            LeadingCharacters = ReadInnerText(reader, true);

                            break;

                        case "pnseclvl" :

                            ReadToEndGround(reader);

                            break;

                        case RTFConstant.PARD :

                            this.startContent = true;

                            if(forbitPard)
                            {
                                continue;
                            }

                            this.paragraphFormat.ResetParagraph();

                            break;

                        case RTFConstant.PAR :
                        {
                            this.startContent = true;

                            if(GetLastElement(typeof(RTFDOMParagraph)) == null)
                            {
                                RTFDOMParagraph paragraph = new RTFDOMParagraph();

                                paragraph.Format = this.paragraphFormat ;

                                this.paragraphFormat = this.paragraphFormat.Clone();

                                AddContentElement(paragraph);

                                paragraph.Locked = true;
                            }
                            else
                            {
                                CompleteParagraph();

                                RTFDOMParagraph paragraph = new RTFDOMParagraph();

                                paragraph.Format = this.paragraphFormat;

                                AddContentElement(paragraph);
                            }

                            this.startContent = true;

                            break;
                        }
                        case RTFConstant.PAGE :

                            this.startContent = true;

                            CompleteParagraph();

                            AddContentElement(new RTFDOMPageBreak());

                            break;

                        case RTFConstant.PAGEBB :

                            this.startContent = true;

                            this.paragraphFormat.PageBreak = true;

                            break;

                        case RTFConstant.QL :

                            this.startContent = true;

                            this.paragraphFormat.TextAlignment = RTFTextAlignment.LEFT;

                            break;

                        case RTFConstant.QC :

                            this.startContent = true;

                            this.paragraphFormat.TextAlignment = RTFTextAlignment.CENTER;

                            break;

                        case RTFConstant.QR :

                            this.startContent = true;

                            this.paragraphFormat.TextAlignment = RTFTextAlignment.RIGHT;

                            break;

                        case RTFConstant.QJ:

                            this.startContent = true;

                            this.paragraphFormat.TextAlignment = RTFTextAlignment.JUSTIFY;

                            break;

                        case RTFConstant.SL :

                            this.startContent = true;

                            if(reader.CurrentParameter >= 0)
                            {
                                this.paragraphFormat.LineSpacing = reader.CurrentParameter;
                            }

                            break;

                        case RTFConstant.SLMULT :

                            this.startContent = true;

                            this.paragraphFormat.MultiLineSpacing = (reader.CurrentParameter == 1);

                            break;

                        case RTFConstant.SB :

                            this.startContent = true;

                            this.paragraphFormat.SpacingBeforeParagraph = reader.CurrentParameter;

                            break;

                        case RTFConstant.SA :

                            this.startContent = true;

                            this.paragraphFormat.SpacingAfterParagraph = reader.CurrentParameter;

                            break;

                        case RTFConstant.FI :

                            this.startContent = true;

                            this.paragraphFormat.ParagraphFirstLineIndent = reader.CurrentParameter;

                            break;

                        case RTFConstant.BRDRW:

                            this.startContent = true;

                            if(reader.HasCurrentParameter)
                            {
                                this.paragraphFormat.BorderWidth = reader.CurrentParameter;
                            }

                            break;

                        case RTFConstant.PN :

                            this.startContent = true;

                            this.paragraphFormat.ListID = -1;

                            break;

                        case RTFConstant.PNTEXT :

                            break;

                        case RTFConstant.PNTXTB :

                            break;

                        case RTFConstant.PNTXTA :

                            break;

                        case RTFConstant.PNLVLBODY :

                            this.startContent = true; 

                            break;

                        case RTFConstant.PNLVLBLT :

                            this.startContent = true; 

                            break;

                        case RTFConstant.LISTTEXT :

                            this.startContent = true; 

                            break;

                        case RTFConstant.LS :

                            this.startContent = true;

                            this.paragraphFormat.ListID = reader.CurrentParameter;

                            break;

                        case RTFConstant.LI :

                            this.startContent = true; 

                            if(reader.HasCurrentParameter)
                            {
                                this.paragraphFormat.LeftIndent = reader.CurrentParameter;
                            }

                            break;

                        case RTFConstant.LINE :
                        {
                            this.startContent = true;

                            if(format.ReadText)
                            {
                                RTFDOMLineBreak lineBreak = new RTFDOMLineBreak();

                                lineBreak.NativeLevel = reader.Level;

                                AddContentElement(lineBreak);
                            }

                            break;
                        }
                        case RTFConstant.INSRSID :

                            break;

                        case RTFConstant.PLAIN :

                            this.startContent = true;

                            format.ResetText();

                            break;

                        case RTFConstant.F :
                        {
                            this.startContent = true;

                            if(format.ReadText)
                            {
                                string fontName = FontTable.GetFontName(reader.CurrentParameter);

                                if(fontName != null)
                                {
                                    fontName = fontName.Trim();
                                }

                                if(fontName == null || fontName.Length == 0)
                                {
                                    fontName = _defaultFontName;
                                }

                                if(ChangeTimesNewRoman)
                                {
                                    if(fontName == "Times New Roman")
                                    {
                                        fontName = _defaultFontName;
                                    }
                                }

                                format.FontName = fontName;
                            }

                            this.fontChartSetEncoding = FontTable[reader.CurrentParameter].Encoding;

                            break;
                        }
                        case RTFConstant.AF :

                            this.associateFontChartSetEncoding = FontTable[reader.CurrentParameter].Encoding;

                            break;

                        case RTFConstant.FS :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                if(reader.HasCurrentParameter)
                                {
                                    format.FontSize = reader.CurrentParameter / 2.0f;
                                }
                            }

                            break;

                        case RTFConstant.CF :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                if(reader.HasCurrentParameter)
                                {
                                    format.TextColor = ColorTable.GetColor(reader.CurrentParameter, Color.Black);
                                }
                            }

                            break;

                        case RTFConstant.CB      :
                        case RTFConstant.CHCBPAT :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                if(reader.HasCurrentParameter)
                                {
                                    format.BackgroundColor = ColorTable.GetColor(reader.CurrentParameter, Color.Empty);
                                }
                            }

                            break;

                        case RTFConstant.B :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                format.Bold = (reader.HasCurrentParameter == false || reader.CurrentParameter != 0);
                            }

                            break;

                        case RTFConstant.V :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                if(reader.HasCurrentParameter && reader.CurrentParameter == 0)
                                {
                                    format.Hidden = false;
                                }
                                else
                                {
                                    format.Hidden = true;
                                }
                            }

                            break;

                        case RTFConstant.HIGHLIGHT :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                if(reader.HasCurrentParameter)
                                {
                                    format.BackgroundColor = ColorTable.GetColor(reader.CurrentParameter , Color.Empty);
                                }
                            }

                            break;

                        case RTFConstant.I :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                format.Italic = (reader.HasCurrentParameter == false || reader.CurrentParameter != 0);
                            }

                            break;

                        case RTFConstant.UL :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                format.Underline = (reader.HasCurrentParameter == false || reader.CurrentParameter != 0);
                            }

                            break;

                        case RTFConstant.NOUL :

                            this.startContent = true;

                            format.Underline = false;

                            break;

                        case RTFConstant.STRIKE :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                format.Strikeout = (reader.HasCurrentParameter == false || reader.CurrentParameter != 0);
                            }

                            break;

                        case RTFConstant.SUB :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                format.Subscript = (reader.HasCurrentParameter == false || reader.CurrentParameter != 0);
                            }

                            break;

                        case RTFConstant.SUPER :

                            this.startContent = true;

                            if(format.ReadText)
                            {
                                format.Superscript = (reader.HasCurrentParameter == false || reader.CurrentParameter != 0);
                            }

                            break;

                        case RTFConstant.NOSUPERSUB :

                            this.startContent = true;

                            format.Subscript   = false;
                            format.Superscript = false;

                            break;

                        case RTFConstant.BRDRB :

                            this.startContent = true;

                            this.paragraphFormat.BottomBorder = true;

                            break;

                        case RTFConstant.BRDRL :

                            this.startContent = true;

                            this.paragraphFormat.LeftBorder = true;

                            break;

                        case RTFConstant.BRDRR :

                            this.startContent = true;

                            this.paragraphFormat.RightBorder = true;

                            break;

                        case RTFConstant.BRDRT :

                            this.startContent = true;

                            this.paragraphFormat.BottomBorder = true;

                            break;

                        case RTFConstant.BRDRCF :
                        {
                            this.startContent = true;

                            RTFDOMElement element = this.GetLastElement(typeof(RTFDOMTableRow) , false);

                            if(element is RTFDOMTableRow)
                            {
                                RTFDOMTableRow row = (RTFDOMTableRow)element;

                                RTFAttributeList attributeList = null;

                                if(row.CellSettingList.Count > 0)
                                {
                                    attributeList = (RTFAttributeList)row.CellSettingList[row.CellSettingList.Count - 1];

                                    attributeList.Add(reader.CurrentKeyword, reader.CurrentParameter);
                                }
                            }
                            else
                            {
                                this.paragraphFormat.BorderColor = ColorTable.GetColor(reader.CurrentParameter , Color.Black);

                                format.BorderColor = format.BorderColor;
                            }

                            break;
                        }
                        case RTFConstant.BRDRS :

                            this.startContent = true;

                            this.paragraphFormat.BorderThickness = false;

                            format.BorderThickness = false;

                            break;

                        case RTFConstant.BRDRTH :

                            this.startContent = true;

                            this.paragraphFormat.BorderThickness = true;

                            format.BorderThickness = true;

                            break;

                        case RTFConstant.BRDRDOT :

                            this.startContent = true;

                            this.paragraphFormat.BorderStyle= DashStyle.Dot;

                            format.BorderStyle = DashStyle.Dot;

                            break;

                        case RTFConstant.BRDRDASH :

                            this.startContent = true;

                            this.paragraphFormat.BorderStyle = DashStyle.Dash;

                            format.BorderStyle = DashStyle.Dash;

                            break;

                        case RTFConstant.BRDRDASHD :

                            this.startContent = true;

                            this.paragraphFormat.BorderStyle = DashStyle.DashDot;

                            format.BorderStyle = DashStyle.DashDot;

                            break;

                        case RTFConstant.BRDRDASHDD :

                            this.startContent = true;

                            this.paragraphFormat.BorderStyle = DashStyle.DashDotDot;

                            format.BorderStyle = DashStyle.DashDotDot;

                            break;

                        case RTFConstant.BRDRNIL :

                            this.startContent = true;

                            this.paragraphFormat.LeftBorder   = false;
                            this.paragraphFormat.TopBorder    = false;
                            this.paragraphFormat.RightBorder  = false;
                            this.paragraphFormat.BottomBorder = false;

                            format.LeftBorder   = false;
                            format.TopBorder    = false;
                            format.RightBorder  = false;
                            format.BottomBorder = false;

                            break;

                        case RTFConstant.BRSP :

                            this.startContent = true;

                            if(reader.HasCurrentParameter)
                            {
                                this.paragraphFormat.BorderSpacing = reader.CurrentParameter;
                            }

                            break;

                        case RTFConstant.CHBRDR :

                            this.startContent = true;

                            format.LeftBorder   = true;
                            format.TopBorder    = true;
                            format.RightBorder  = true;
                            format.BottomBorder = true;

                            break;

                        case RTFConstant.BKMKSTART :
                        {
                            this.startContent = true;

                            if(format.ReadText && this.startContent)
                            {
                                RTFDOMBookmark bookmark = new RTFDOMBookmark();

                                bookmark.Name   = ReadInnerText(reader, true);
                                bookmark.Locked = true;

                                AddContentElement(bookmark);
                            }

                            break;
                        }
                        case RTFConstant.BKMKEND :

                            forbitPard = true;

                            format.ReadText = false;

                            break;

                        case RTFConstant.FIELD :

                            this.startContent = true;

                            ReadDOMField(reader, format);

                            return;

                        case RTFConstant.OBJECT :

                            this.startContent = true;

                            ReadDOMObject(reader, format);

                            return;

                        case RTFConstant.SHPPICT :

                            break;

                        case RTFConstant.NONSHPPICT :

                            ReadToEndGround(reader);

                            break;

                        case RTFConstant.PICT :
                        {
                            this.startContent = true;

                            RTFDOMImage image = new RTFDOMImage();

                            image.NativeLevel = reader.Level;

                            AddContentElement(image);

                            break;
                        }
                        case RTFConstant.PICSCALEX :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.ScaleX = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.PICSCALEY :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.ScaleY = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.PICWGOAL :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.DesiredWidth = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.PICHGOAL :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.DesiredHeight = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.BLIPUID :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.ID = ReadInnerText(reader, true);
                            }

                            break;
                        }
                        case RTFConstant.EMFBLIP :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.EMF;
                            }

                            break;
                        }
                        case RTFConstant.PNGBLIP :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.PNG;
                            }

                            break;
                        }
                        case RTFConstant.JPEGBLIP :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.JPEG;
                            }

                            break;
                        }
                        case RTFConstant.MACPICT :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.PICT;
                            }

                            break;
                        }
                        case RTFConstant.PMMETAFILE :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.OS2METAFILE;
                            }

                            break;
                        }
                        case RTFConstant.WMETAFILE :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.METAFILE;
                            }

                            break;
                        }
                        case RTFConstant.DIBITMAP :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.DIB;
                            }

                            break;
                        }
                        case RTFConstant.WBITMAP :
                        {
                            RTFDOMImage image = (RTFDOMImage)GetLastElement(typeof(RTFDOMImage));

                            if(image != null)
                            {
                                image.PictureType = RTFPictureType.BITMAP;
                            }

                            break;
                        }
                        case RTFConstant.SP :
                        {
                            int    level = 0;
                            string name  = null;
                            string value = null;

                            while(reader.ReadToken() != null)
                            {
                                if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                                {
                                    level++;
                                }
                                else if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                                {
                                    level--;

                                    if(level < 0)
                                    {
                                        break;
                                    }
                                }
                                else if(reader.CurrentKeyword == RTFConstant.SN)
                                {
                                    name = ReadInnerText(reader, true);
                                }
                                else if(reader.CurrentKeyword == RTFConstant.SV)
                                {
                                    value = ReadInnerText(reader, true);
                                }
                            }

                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.AttrbuteCollection[name] = value;
                            }
                            else
                            {
                                RTFDOMShapeGroup shapeGroup = (RTFDOMShapeGroup)GetLastElement(typeof(RTFDOMShapeGroup));

                                if(shapeGroup != null)
                                {
                                    shapeGroup.AttrbuteCollection[name] = value;
                                }
                            }

                            break;
                        }
                        case RTFConstant.SHPTXT :

                            break;

                        case RTFConstant.SHPRSLT :

                            ReadToEndGround(reader);

                            break  ;

                        case RTFConstant.SHP :
                        {
                            this.startContent = true;

                            RTFDOMShape shape = new RTFDOMShape();

                            shape.NativeLevel = reader.Level;

                            AddContentElement(shape);

                            break;
                        }
                        case RTFConstant.SHPLEFT :
                        {
                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.Left = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.SHPTOP :
                        {
                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.Top = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.SHPRIGHT :
                        {
                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.Width = reader.CurrentParameter - shape.Left;
                            }

                            break;
                        }
                        case RTFConstant.SHPBOTTOM :
                        {
                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.Height = reader.CurrentParameter - shape.Top;
                            }

                            break;
                        }
                        case RTFConstant.SHPLID :
                        {
                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.ShapeID = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.SHPZ :
                        {
                            RTFDOMShape shape = (RTFDOMShape)GetLastElement(typeof(RTFDOMShape));

                            if(shape != null)
                            {
                                shape.ZIndex = reader.CurrentParameter;
                            }

                            break;
                        }
                        case RTFConstant.SHPGRP :
                        {
                            RTFDOMShapeGroup shapeGroup = new RTFDOMShapeGroup();

                            shapeGroup.NativeLevel = reader.Level;

                            AddContentElement(shapeGroup);

                            break;
                        }
                        case RTFConstant.SHPINST :

                            break;

                        case RTFConstant.INTBL :
                        case RTFConstant.TROWD :
                        case RTFConstant.ITAP  :
                        {
                            this.startContent = true;

                            RTFDOMElement[] lastElementArray  = GetLastElementArray(true);
                            RTFDOMElement   lastUnlockElement = null;
                            RTFDOMElement   lastTableElement  = null;

                            for(int i = lastElementArray.Length - 1; i >= 0; i--)
                            {
                                RTFDOMElement element = lastElementArray[i];

                                if(element.Locked == false)
                                {
                                    if(lastUnlockElement == null && !(element is RTFDOMParagraph))
                                    {
                                        lastUnlockElement = element;
                                    }

                                    if(element is RTFDOMTableRow || element is RTFDOMTableCell)
                                    {
                                        lastTableElement = element;

                                        break;
                                    }
                                }
                            }

                            if(reader.CurrentKeyword == RTFConstant.INTBL)
                            {
                                if(lastTableElement == null)
                                {
                                    RTFDOMTableRow row = new RTFDOMTableRow();

                                    row.NativeLevel = reader.Level;

                                    lastUnlockElement.AppendChild(row);
                                }
                            }
                            else if(reader.CurrentKeyword == RTFConstant.TROWD)
                            {
                                RTFDOMTableRow row = null;

                                if(lastTableElement == null)
                                {
                                    row = new RTFDOMTableRow();

                                    row.NativeLevel = reader.Level;

                                    lastUnlockElement.AppendChild(row);
                                }
                                else
                                {
                                    row = lastTableElement as RTFDOMTableRow;

                                    if(row == null)
                                    {
                                        row = (RTFDOMTableRow)lastTableElement.ParentElement;
                                    }
                                }

                                row.AttributeList.Clear();
                                row.CellSettingList.Clear();

                                this.paragraphFormat.ResetParagraph();
                            }
                            else if(reader.CurrentKeyword == RTFConstant.ITAP)
                            {
                                RTFDOMTableRow row = null;

                                if(reader.CurrentParameter == 0)
                                {
                                }
                                else
                                {
                                    if(lastTableElement == null)
                                    {
                                        row = new RTFDOMTableRow();

                                        row.NativeLevel = reader.Level;

                                        lastUnlockElement.AppendChild(row);
                                    }
                                    else
                                    {
                                        row = lastTableElement as RTFDOMTableRow;

                                        if(row == null)
                                        {
                                            row = (RTFDOMTableRow)lastTableElement.ParentElement;
                                        }
                                    }

                                    if(reader.CurrentParameter == row.Level)
                                    {
                                    }
                                    else if(reader.CurrentParameter > row.Level)
                                    {
                                        RTFDOMTableRow newRow = new RTFDOMTableRow();

                                        newRow.Level = reader.CurrentParameter;

                                        RTFDOMTableCell parentCell = (RTFDOMTableCell)GetLastElement(typeof(RTFDOMTableCell), false);

                                        if(parentCell == null)
                                        {
                                            AddContentElement(newRow);
                                        }
                                        else
                                        {
                                            parentCell.AppendChild(newRow);
                                        }
                                    }
                                    else if(reader.CurrentParameter < row.Level)
                                    {
                                    }
                                }
                            }

                            break;
                        }
                        case RTFConstant.NESTTABLEPROPS :

                            break;

                        case RTFConstant.ROW :
                        {
                            this.startContent = true;

                            RTFDOMElement[] lastElementArray = GetLastElementArray(true);

                            for(int i = lastElementArray.Length - 1; i >= 0; i--)
                            {
                                lastElementArray[i].Locked = true;

                                if(lastElementArray[i] is RTFDOMTableRow)
                                {
                                    break;
                                }
                            }

                            break;
                        }
                        case RTFConstant.NESTROW :
                        {
                            this.startContent = true;

                            RTFDOMElement[] elementArray = GetLastElementArray(true);

                            for(int i = elementArray.Length - 1; i >= 0; i--)
                            {
                                elementArray[i].Locked = true;

                                if(elementArray[i] is RTFDOMTableRow)
                                {
                                    break;
                                }
                            }

                            break;
                        }
                        case RTFConstant.TRRH         :
                        case RTFConstant.TRAUTOFIT    :
                        case RTFConstant.IROWBAND     :
                        case RTFConstant.TRHDR        :
                        case RTFConstant.TRKEEP       :
                        case RTFConstant.TRKEEPFOLLOW :
                        case RTFConstant.TRLEFT       :
                        case RTFConstant.TRQC         :
                        case RTFConstant.TRQL         :
                        case RTFConstant.TRQR         :
                        case RTFConstant.TRCBPAT      :
                        case RTFConstant.TRCFPAT      :
                        case RTFConstant.TRPAT        :
                        case RTFConstant.TRSHDNG      :
                        case RTFConstant.TRWWIDTH     :
                        case RTFConstant.TRWWIDTHA    :
                        case RTFConstant.IROW         :
                        case RTFConstant.TRPADDB      :
                        case RTFConstant.TRPADDL      :
                        case RTFConstant.TRPADDR      :
                        case RTFConstant.TRPADDT      :
                        case RTFConstant.TRPADDFB     :
                        case RTFConstant.TRPADDFL     :
                        case RTFConstant.TRPADDFR     :
                        case RTFConstant.TRPADDFT     :
                        case RTFConstant.LASTROW      :
                        {
                            this.startContent = true;

                            RTFDOMTableRow row = (RTFDOMTableRow)GetLastElement(typeof(RTFDOMTableRow), false);

                            if(row != null)
                            {
                                row.AttributeList.Add(reader.CurrentKeyword , reader.CurrentParameter);
                            }

                            break;
                        }
                        case RTFConstant.CLVMGF    :
                        case RTFConstant.CLVMRG    :
                        case RTFConstant.CELLX     :
                        case RTFConstant.CLVERTALT :
                        case RTFConstant.CLVERTALC :
                        case RTFConstant.CLVERTALB :
                        case RTFConstant.CLNOWRAP  :
                        case RTFConstant.CLCBPAT   :
                        case RTFConstant.CLCFPAT   :
                        case RTFConstant.CLPADL    :
                        case RTFConstant.CLPADT    :
                        case RTFConstant.CLPADR    :
                        case RTFConstant.CLPADB    :
                        case RTFConstant.CLBRDRL   :
                        case RTFConstant.CLBRDRT   :
                        case RTFConstant.CLBRDRR   :
                        case RTFConstant.CLBRDRB   :
                        case RTFConstant.BRDRTBL   :
                        case RTFConstant.BRDRNONE  :
                        {
                            this.startContent = true;

                            RTFDOMTableRow row = (RTFDOMTableRow)GetLastElement(typeof(RTFDOMTableRow), false);

                            RTFAttributeList attributeList = null;

                            if(row.CellSettingList.Count > 0)
                            {
                                attributeList = (RTFAttributeList)row.CellSettingList[row.CellSettingList.Count - 1];

                                if(attributeList.Contains(RTFConstant.CELLX))
                                {
                                    attributeList = new RTFAttributeList();

                                    row.CellSettingList.Add(attributeList);
                                }
                            }

                            if(attributeList == null)
                            {
                                attributeList = new RTFAttributeList();

                                row.CellSettingList.Add(attributeList);
                            }

                            attributeList.Add(reader.CurrentKeyword, reader.CurrentParameter);

                            break;
                        }
                        case RTFConstant.CELL :
                        {
                            this.startContent = true;

                            AddContentElement(null);

                            CompleteParagraph();

                            this.paragraphFormat.Reset();

                            format.Reset();

                            RTFDOMElement[] lastElementArray = GetLastElementArray(true);

                            for(int i = lastElementArray.Length - 1; i >= 0; i--)
                            {
                                if(lastElementArray[i].Locked == false)
                                {
                                    lastElementArray[i].Locked = true;

                                    if(lastElementArray[i] is RTFDOMTableCell)
                                    {
                                        break;
                                    }
                                }
                            }

                            break;
                        }
                        case RTFConstant.NESTCELL :
                        {
                            this.startContent = true;

                            AddContentElement(null);

                            CompleteParagraph();

                            RTFDOMElement[] lastElementArray = GetLastElementArray(false);

                            for(int i = lastElementArray.Length - 1; i >= 0; i--)
                            {
                                lastElementArray[i].Locked = true;

                                if(lastElementArray[i] is RTFDOMTableCell)
                                {
                                    ((RTFDOMTableCell)lastElementArray[i]).Format = format;

                                    break;
                                }
                            }

                            break;
                        }
                        default :

                            if(reader.CurrentTokenType == RTFTokenType.ExtendedKeyword && reader.FirstTokenInGroup)
                            {
                                ReadToEndGround(reader);

                                break ;
                            }

                            break;
                    }
                }
            }

            if(textContainer.HasContent)
            {
                ApplyText(textContainer, reader, format);
            }
        }

        #endregion
        #region  б - ReadToEndGround(reader)

        /// <summary>
        ///  б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadToEndGround(RTFReader reader)
        {
            reader.ReadToEndGround();
        }

        #endregion
        #region Ʈ ̵ ̺ б - ReadListOverrideTable(reader)

        /// <summary>
        /// Ʈ ̵ ̺ б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadListOverrideTable(RTFReader reader)
        {
            this.listOverrideTable = new RTFListOverrideTable();

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    break;
                }
                else if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                    int level = reader.Level;

                    RTFListOverride listOverride = null;

                    while(reader.ReadToken() != null)
                    {
                        if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                        {
                            break;
                        }

                        if(reader.CurrentToken.Keyword == "listoverride")
                        {
                            listOverride = new RTFListOverride();

                            this.listOverrideTable.Add(listOverride);

                            continue;
                        }

                        if(listOverride == null)
                        {
                            continue;
                        }

                        switch(reader.CurrentToken.Keyword)
                        {
                            case "listid" :

                                listOverride.ListID = reader.CurrentToken.Parameter;

                                break;

                            case "listoverridecount" :

                                listOverride.ListOverriedCount = reader.CurrentToken.Parameter;

                                break;

                            case "ls" :

                                listOverride.ID = reader.CurrentToken.Parameter;

                                break;
                        }
                    }
                }
            }
        }

        #endregion
        #region HTML Ʈ б - ReadHTMLContent(reader)

        /// <summary>
        /// HTML Ʈ б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadHTMLContent(RTFReader reader)
        {
            StringBuilder stringBuilder = new StringBuilder();

            bool htmlState = true;

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentKeyword == "htmlrtf")
                {
                    if(reader.HasCurrentParameter && reader.CurrentParameter == 0)
                    {
                        htmlState = false;
                    }
                    else
                    {
                        htmlState = true;
                    }
                }
                else if(reader.CurrentKeyword == "htmltag")
                {
                    if(reader.InnerReader.Peek() == (int)' ')
                    {
                        reader.InnerReader.Read();
                    }

                    string text = ReadInnerText(reader, null, true, false, true);

                    if(string.IsNullOrEmpty(text) == false)
                    {
                        stringBuilder.Append(text);
                    }
                }
                else if(reader.CurrentTokenType == RTFTokenType.Keyword || reader.CurrentTokenType == RTFTokenType.ExtendedKeyword)
                {
                    if(htmlState == false)
                    {
                        switch(reader.CurrentKeyword)
                        {
                            case "par"       : stringBuilder.Append(Environment.NewLine); break;
                            case "line"      : stringBuilder.Append(Environment.NewLine); break;
                            case "tab"       : stringBuilder.Append("\t");                break;
                            case "lquote"    : stringBuilder.Append("&lsquo;");           break;
                            case "rquote"    : stringBuilder.Append("&rsquo;");           break;
                            case "ldblquote" : stringBuilder.Append("&ldquo;");           break;
                            case "rdblquote" : stringBuilder.Append("&rdquo;");           break;
                            case "bullet"    : stringBuilder.Append("&bull;" );           break;
                            case "endash"    : stringBuilder.Append("&ndash;");           break;
                            case "emdash"    : stringBuilder.Append("&mdash;");           break;
                            case "~"         : stringBuilder.Append("&nbsp;" );           break;
                            case "_"         : stringBuilder.Append("&shy;"  );           break;
                        }
                    }
                }
                else if(reader.CurrentTokenType == RTFTokenType.Text)
                {
                    if(htmlState == false)
                    {
                        stringBuilder.Append(reader.CurrentKeyword);
                    }
                }
            }

            HTMLContent = stringBuilder.ToString();
        }

        #endregion
        #region Ʈ ̺ б - ReadListTable(reader)

        /// <summary>
        /// Ʈ ̺ б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadListTable(RTFReader reader)
        {
            this.listTable = new RTFListTable();

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    break;
                }
                else if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                    bool    firstRead   = true;
                    RTFList currentList = null;
                    int     level       = reader.Level;

                    while(reader.ReadToken() != null)
                    {
                        if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                        {
                            if(reader.Level < level)
                            {
                                break;
                            }
                        }
                        else if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                        {
                        }

                        if(firstRead)
                        {
                            if(reader.CurrentToken.Keyword != "list")
                            {
                                ReadToEndGround(reader);

                                reader.ReadToken();

                                break;
                            }

                            currentList = new RTFList();

                            this.listTable.Add(currentList);

                            firstRead = false;
                        }

                        switch(reader.CurrentToken.Keyword)
                        {
                            case "listtemplateid" :

                                currentList.ListTemplateID = reader.CurrentToken.Parameter;

                                break;

                            case "listid" :

                                currentList.ListID = reader.CurrentToken.Parameter;

                                break;

                            case "listhybrid" :

                                currentList.ListHybrid = true;

                                break;

                            case "levelfollow" :

                                currentList.LevelFollow = reader.CurrentToken.Parameter;

                                break;

                            case "levelstartat" :

                                currentList.LevelStartAt = reader.CurrentToken.Parameter;

                                break;

                            case "levelnfc" :

                                if(currentList.NFCLevelNumberType == LevelNumberType.NONE)
                                {
                                    currentList.NFCLevelNumberType = (LevelNumberType)reader.CurrentToken.Parameter;
                                }

                                break;

                            case "levelnfcn" :

                                if(currentList.NFCLevelNumberType == LevelNumberType.NONE)
                                {
                                    currentList.NFCLevelNumberType = (LevelNumberType)reader.CurrentToken.Parameter;
                                }

                                break;

                            case "leveljc" :

                                currentList.JCLevel = reader.CurrentToken.Parameter;

                                break;

                            case "leveltext" :

                                if(string.IsNullOrEmpty(currentList.LevelText))
                                {
                                    string text = ReadInnerText(reader, true);

                                    if(text != null && text.Length > 2)
                                    {
                                        int length = (int)text[0];

                                        length = Math.Min(length, text.Length - 1);

                                        text = text.Substring(1, length);
                                    }

                                    currentList.LevelText = text ;
                                }

                                break;

                            case "f" :

                                currentList.FontName = this.FontTable.GetFontName(reader.CurrentToken.Parameter);

                                break;
                        }
                    }
                }
            }
        }

        #endregion
        #region Ʈ ̺ б - ReadFontTable(reader)

        /// <summary>
        /// Ʈ ̺ б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadFontTable(RTFReader reader)
        {
            this.fontTable.Clear();

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    break;
                }
                else if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                    int    index   = -1;
                    string name    = null;
                    int    characterSet = 1;
                    bool   isNull  = false;

                    while(reader.ReadToken() != null)
                    {
                        if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                        {
                            break;
                        }
                        else if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                        {
                            reader.ReadToken();

                            ReadToEndGround(reader);

                            reader.ReadToken();
                        }
                        else if(reader.CurrentKeyword == "f" && reader.HasCurrentParameter)
                        {
                            index = reader.CurrentParameter;
                        }
                        else if(reader.CurrentKeyword == "fnil")
                        {
                            name = Control.DefaultFont.Name;

                            isNull = true;
                        }
                        else if(reader.CurrentKeyword == RTFConstant.FCHARSET)
                        {
                            characterSet = reader.CurrentParameter;
                        }
                        else if(reader.CurrentToken.IsTextToken)
                        {
                            name = ReadInnerText(reader, reader.CurrentToken, false, false , false);

                            if(name != null)
                            {
                                name = name.Trim();

                                if(name.EndsWith(";"))
                                {
                                    name = name.Substring(0, name.Length - 1);
                                }
                            }
                        }
                    }

                    if(index >= 0 && name != null)
                    {
                        if(name.EndsWith(";"))
                        {
                            name = name.Substring(0, name.Length - 1);
                        }

                        name = name.Trim();

                        if(string.IsNullOrEmpty(name))
                        {
                            name = Control.DefaultFont.Name;
                        }

                        RTFFont font = new RTFFont(index, name);

                        font.CharacterSet = characterSet;
                        font.IsNull       = isNull;

                        this.fontTable.Add(font);
                    }
                }
            }
        }

        #endregion
        #region  ̺ б - ReadColorTable(reader)

        /// <summary>
        ///  ̺ б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadColorTable(RTFReader reader)
        {
            this.colorTable.Clear();

            this.colorTable.CheckValueExistWhenAdd = false;

            int red   = -1;
            int green = -1;
            int blue  = -1;

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    break;
                }

                switch(reader.CurrentKeyword)
                {
                    case "red" :

                        red = reader.CurrentParameter;

                        break;

                    case "green" :

                        green = reader.CurrentParameter;

                        break;

                    case "blue" :

                        blue = reader.CurrentParameter;

                        break;

                    case ";" :

                        if(red >= 0 && green >= 0 && blue >= 0)
                        {
                            Color color = Color.FromArgb(255, red, green, blue);

                            this.colorTable.Add(color);

                            red   = -1;
                            green = -1;
                            blue  = -1;
                        }

                        break;
                }
            }

            if(red >= 0 && green >= 0 && blue >= 0)
            {
                Color color = Color.FromArgb(255, red, green, blue);

                this.colorTable.Add(color);
            }
        }

        #endregion
        #region   б - ReadDocumentInfo(reader)

        /// <summary>
        ///   б
        /// </summary>
        /// <param name="reader">RTF </param>
        private void ReadDocumentInfo(RTFReader reader)
        {
            this.documentInfo.Clear();

            int level = 0;

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                    level++;
                }
                else if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    level--;

                    if(level < 0)
                    {
                        break;
                    }
                }
                else
                {
                    switch(reader.CurrentKeyword)
                    {
                        case "creatim" :

                            this.documentInfo.CreateTime = ReadDateTime(reader);

                            level--;

                            break;

                        case "revtim" :

                            this.documentInfo.UpdateTime = ReadDateTime(reader);

                            level--;

                            break;

                        case "printim" :

                            this.documentInfo.PrintTime = ReadDateTime(reader);

                            level--;

                            break;

                        case "buptim" :

                            this.documentInfo.BackupTime = ReadDateTime(reader);

                            level--;

                            break;

                        default :

                            if(reader.CurrentKeyword != null)
                            {
                                if(reader.HasCurrentParameter)
                                {
                                    this.documentInfo.SetInfo(reader.CurrentKeyword, reader.CurrentParameter.ToString());
                                }
                                else
                                {
                                    this.documentInfo.SetInfo(reader.CurrentKeyword, ReadInnerText(reader, true));
                                }
                            }
                            break;
                    }
                }
            }
        }

        #endregion
        #region ¥/ð б - ReadDateTime(reader)

        /// <summary>
        /// ¥/ð б
        /// </summary>
        /// <param name="reader">RTF </param>
        /// <returns>¥/ð</returns>
        private DateTime ReadDateTime(RTFReader reader)
        {
            int year   = 1900;
            int month  = 1;
            int day    = 1;
            int hour   = 0;
            int minute = 0;
            int second = 0;

            while(reader.ReadToken() != null)
            {
                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    break;
                }

                switch(reader.CurrentKeyword)
                {
                    case "yr"  : year   = reader.CurrentParameter; break;
                    case "mo"  : month  = reader.CurrentParameter; break;
                    case "dy"  : day    = reader.CurrentParameter; break;
                    case "hr"  : hour   = reader.CurrentParameter; break;
                    case "min" : minute = reader.CurrentParameter; break;
                    case "sec" : second = reader.CurrentParameter; break;
                }
            }

            return new DateTime(year, month, day, hour, minute, second);
        }

        #endregion
        #region DOM ü б - ReadDOMObject(reader, format)

        /// <summary>
        /// DOM ü б
        /// </summary>
        /// <param name="reader">RTF </param>
        /// <param name="format">  </param>
        /// <returns>DOM ü</returns>
        private RTFDOMObject ReadDOMObject(RTFReader reader, RTFDocumentFormatInfo format)
        {
            RTFDOMObject domObject = new RTFDOMObject();

            domObject.NativeLevel = reader.Level;

            AddContentElement(domObject);

            int levelBack = reader.Level;

            while(reader.ReadToken() != null)
            {
                if(reader.Level < levelBack)
                {
                    break;
                }

                if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                    continue;
                }

                if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                    continue;
                }

                if(reader.Level == domObject.NativeLevel + 1 && reader.CurrentKeyword.StartsWith("attribute_"))
                {
                    domObject.CustomAttributeDictionary[reader.CurrentKeyword] = ReadInnerText(reader, true);
                }

                switch(reader.CurrentKeyword)
                {
                    case RTFConstant.OBJAUTLINK :

                        domObject.ObjectType = RTFObjectType.AUTLINK;

                        break;

                    case RTFConstant.OBJCLASS :

                        domObject.ClassName = ReadInnerText(reader, true);

                        break;

                    case RTFConstant.OBJDATA :

                        string data = ReadInnerText(reader, true);

                        domObject.ContentByteArray = GetByteArray(data);

                        break;

                    case RTFConstant.OBJEMB :

                        domObject.ObjectType = RTFObjectType.EMB;

                        break;

                    case RTFConstant.OBJH :

                        domObject.Height = reader.CurrentParameter;

                        break;

                    case RTFConstant.OBJHTML :

                        domObject.ObjectType = RTFObjectType.HTML;

                        break;

                    case RTFConstant.OBJICEMB :

                        domObject.ObjectType = RTFObjectType.ICEMB;

                        break;

                    case RTFConstant.OBJLINK :

                        domObject.ObjectType = RTFObjectType.LINK;

                        break;

                    case RTFConstant.OBJNAME :

                        domObject.Name = ReadInnerText(reader, true);

                        break;

                    case RTFConstant.OBJOCX :

                        domObject.ObjectType = RTFObjectType.OCX;

                        break;

                    case RTFConstant.OBJPUB :

                        domObject.ObjectType = RTFObjectType.PUB;

                        break;

                    case RTFConstant.OBJSUB :

                        domObject.ObjectType = RTFObjectType.SUB;

                        break;

                    case RTFConstant.OBJTIME :

                        break;

                    case RTFConstant.OBJW :

                        domObject.Width = reader.CurrentParameter;

                        break;

                    case RTFConstant.OBJSCALEX :

                        domObject.ScaleX = reader.CurrentParameter;

                        break;

                    case RTFConstant.OBJSCALEY :

                        domObject.ScaleY = reader.CurrentParameter;

                        break;

                    case RTFConstant.RESULT :

                        RTFDOMElementContainer elementContainer = new RTFDOMElementContainer();

                        elementContainer.Name = RTFConstant.RESULT;

                        domObject.AppendChild(elementContainer);

                        Load(reader, format);

                        elementContainer.Locked = true;

                        break;
                }
            }

            domObject.Locked = true;

            return domObject;
        }

        #endregion
        #region DOM ʵ б - ReadDOMField(reader, format)

        /// <summary>
        /// DOM ʵ б
        /// </summary>
        /// <param name="reader">RTF </param>
        /// <param name="format">  </param>
        /// <returns>DOM ʵ</returns>
        private RTFDOMField ReadDOMField(RTFReader reader, RTFDocumentFormatInfo format)
        {
            RTFDOMField field = new RTFDOMField();

            field.NativeLevel = reader.Level;

            AddContentElement(field);

            int levelBack = reader.Level;

            while(reader.ReadToken() != null)
            {
                if(reader.Level < levelBack)
                {
                    break;
                }

                if(reader.CurrentTokenType == RTFTokenType.GroupStart)
                {
                }
                else if(reader.CurrentTokenType == RTFTokenType.GroupEnd)
                {
                }
                else
                {
                    switch(reader.CurrentKeyword)
                    {
                        case RTFConstant.FLDDIRTY :

                            field.Method = RTFDOMFieldMethod.DIRTY;

                            break;

                        case RTFConstant.FLDEDIT :

                            field.Method = RTFDOMFieldMethod.EDIT;

                            break;

                        case RTFConstant.FLDLOCK :

                            field.Method = RTFDOMFieldMethod.LOCK;

                            break;

                        case RTFConstant.FLDPRIV :

                            field.Method = RTFDOMFieldMethod.PRIV;

                            break;

                        case RTFConstant.FLDRSLT :
                        {
                            RTFDOMElementContainer elementContainer = new RTFDOMElementContainer();

                            elementContainer.Name = RTFConstant.FLDRSLT;

                            field.AppendChild(elementContainer);

                            Load(reader, format);

                            elementContainer.Locked = true;

                            break;
                        }
                        case RTFConstant.FLDINST :
                        {
                            RTFDOMElementContainer elementContainer = new RTFDOMElementContainer();

                            elementContainer.Name = RTFConstant.FLDINST;

                            field.AppendChild(elementContainer);

                            Load(reader, format);

                            elementContainer.Locked = true;

                            string text = elementContainer.InnerText;

                            if(text != null)
                            {
                                int index = text.IndexOf(RTFConstant.HYPERLINK);

                                if(index >= 0)
                                {
                                    string link   = null;
                                    int    index1 = text.IndexOf('\"', index);

                                    if(index1 > 0 && text.Length > index1 + 2)
                                    {
                                        int index2 = text.IndexOf('\"', index1 + 2);

                                        if(index2 > index1)
                                        {
                                            link = text.Substring(index1 + 1, index2 - index1 - 1);

                                            if(format.Parent != null)
                                            {
                                                if(link.StartsWith("_Toc"))
                                                {
                                                    link = "#" + link;
                                                }

                                                format.Parent.Link = link;
                                            }

                                            break;
                                        }
                                    }
                                }
                            }

                            break;
                        }
                    }
                }
            }

            field.Locked = true;

            return field;
        }

        #endregion
        #region  ؽƮ б - ReadInnerText(reader, firstToken, readSubsidaryLevel, breakMeetControlWord, htmlMode)

        /// <summary>
        ///  ؽƮ б
        /// </summary>
        /// <param name="reader">RTF </param>
        /// <param name="firstToken">ù° ū</param>
        /// <param name="readSubsidaryLevel">  б </param>
        /// <param name="breakMeetControlWord">  ߽߰ 극ũ </param>
        /// <param name="htmlMode">html </param>
        /// <returns> ؽƮ</returns>
        private string ReadInnerText(RTFReader reader, RTFToken firstToken, bool readSubsidaryLevel, bool breakMeetControlWord, bool htmlMode)
        {
            int level = 0;

            RTFTextContainer textContainer = new RTFTextContainer(this);

            textContainer.Accept(firstToken , reader);

            while(true)
            {
                RTFTokenType tokenType = reader.PeekTokenType();

                if(tokenType == RTFTokenType.EOF)
                {
                    break;
                }

                if(tokenType == RTFTokenType.GroupStart)
                {
                    level++;
                }
                else if(tokenType == RTFTokenType.GroupEnd)
                {
                    level--;

                    if(level < 0)
                    {
                        break;
                    }
                }

                reader.ReadToken();

                if(readSubsidaryLevel || level == 0)
                {
                    if(htmlMode)
                    {
                        if(reader.CurrentKeyword == "par")
                        {
                            textContainer.Append(Environment.NewLine);

                            continue;
                        }
                    }

                    if(textContainer.Accept(reader.CurrentToken , reader))
                    {
                        continue;
                    }
                    else
                    {
                        if(breakMeetControlWord)
                        {
                            break;
                        }
                    }
                }
            }

            return textContainer.Text;
        }

        #endregion
        #region  ؽƮ б - ReadInnerText(reader, readSubsidaryLevel)

        /// <summary>
        ///  ؽƮ б
        /// </summary>
        /// <param name="reader">RTF </param>
        /// <param name="readSubsidaryLevel">  б </param>
        /// <returns> ؽƮ</returns>
        private string ReadInnerText(RTFReader reader, bool readSubsidaryLevel)
        {
            return ReadInnerText(reader, null, readSubsidaryLevel, false, false);
        }

        #endregion
    }
}