using System;
using System.ComponentModel;
using System.Text;
using System.Xml.Serialization;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM Ʈ
    /// </summary>
    public abstract class RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region Field

        /// <summary>
        /// Ƽ 
        /// </summary>
        [NonSerialized]
        internal int NativeLevel = -1;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// RTF Ư Ʈ
        /// </summary>
        private RTFAttributeList attributeList = new RTFAttributeList();

        /// <summary>
        /// RTF DOM Ʈ Ʈ
        /// </summary>
        private RTFDOMElementList elementList = new RTFDOMElementList();

        /// <summary>
        ///  RTF DOM 
        /// </summary>
        private RTFDOMDocument ownerDocument = null;

        /// <summary>
        /// θ RTF DOM Ʈ
        /// </summary>
        private RTFDOMElement parentElement = null;

        /// <summary>
        ///  
        /// </summary>
        private bool locked = false;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ư Ʈ - AttributeList

        /// <summary>
        /// Ư Ʈ
        /// </summary>
        public RTFAttributeList AttributeList
        {
            get
            {
                return this.attributeList;
            }
            set
            {
                this.attributeList = value;
            }
        }

        #endregion
        #region Ʈ Ʈ - ElementList

        /// <summary>
        /// Ʈ Ʈ
        /// </summary>
        public RTFDOMElementList ElementList
        {
            get
            {
                return this.elementList;
            }
        }

        #endregion
        #region   - OwnerDocument

        /// <summary>
        ///  
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public RTFDOMDocument OwnerDocument
        {
            get
            {
                return this.ownerDocument;
            }
            set
            {
                this.ownerDocument = value;

                foreach(RTFDOMElement element in ElementList)
                {
                    element.OwnerDocument = value;
                }
            }
        }

        #endregion
        #region θ Ʈ - ParentElement

        /// <summary>
        /// θ Ʈ
        /// </summary>
        [Browsable(false)]
        public RTFDOMElement ParentElement
        {
            get
            {
                return this.parentElement;
            }
        }

        #endregion
        #region  ؽƮ - InnerText

        /// <summary>
        ///  ؽƮ
        /// </summary>
        [Browsable(false)]
        public virtual string InnerText
        {
            get
            {
                StringBuilder stringBuilder = new StringBuilder();

                if(this.elementList != null)
                {
                    foreach(RTFDOMElement element in this.elementList)
                    {
                        stringBuilder.Append(element.InnerText);
                    }
                }

                return stringBuilder.ToString();
            }
        }

        #endregion
        #region   - Locked

        /// <summary>
        ///  
        /// </summary>
        [XmlIgnore]
        [Browsable(false)]
        public bool Locked
        {
            get 
            {
                return this.locked; 
            }
            set
            {
                this.locked = value; 
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ư   ϱ - HasAttribute(name)

        /// <summary>
        /// Ư   ϱ
        /// </summary>
        /// <param name="name">Ī</param>
        /// <returns>Ư  </returns>
        public bool HasAttribute(string name)
        {
            return this.attributeList.Contains(name);
        }

        #endregion
        #region Ư  ϱ - GetAttributeValue(name, defaultValue)

        /// <summary>
        /// Ư  ϱ
        /// </summary>
        /// <param name="name">Ī</param>
        /// <param name="defaultValue">Ʈ </param>
        /// <returns>Ư </returns>
        public int GetAttributeValue(string name, int defaultValue)
        {
            if(this.attributeList.Contains(name))
            {
                return this.attributeList[name];
            }
            else
            {
                return defaultValue;
            }
        }

        #endregion
        #region ڽ ߰ϱ - AppendChild(element)

        /// <summary>
        /// ڽ ߰ϱ
        /// </summary>
        /// <param name="element">Ʈ</param>
        /// <returns>ε</returns>
        public int AppendChild(RTFDOMElement element)
        {
            CheckLocked();

            element.parentElement = this;

            element.OwnerDocument = this.ownerDocument;

            return this.elementList.Add(element);
        }

        #endregion
        #region Ư ϱ - SetAttribute(name, value)

        /// <summary>
        /// Ư ϱ
        /// </summary>
        /// <param name="name">Ī</param>
        /// <param name="value"></param>
        public void SetAttribute(string name, int value)
        {
            CheckLocked();

            this.attributeList[name] = value;
        }

        #endregion
        #region   ϱ - SetLockedDeeply(locked)

        /// <summary>
        ///   ϱ
        /// </summary>
        /// <param name="locked"> </param>
        public void SetLockedDeeply(bool locked)
        {
            this.locked = locked;

            if(this.elementList != null)
            {
                foreach(RTFDOMElement element in this.elementList)
                {
                    element.SetLockedDeeply(locked);
                }
            }
        }

        #endregion
        #region DOM ڿ ϱ - GetDOMString()

        /// <summary>
        /// DOM ڿ ϱ
        /// </summary>
        /// <returns>DOM ڿ</returns>
        public virtual string GetDOMString()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.Append(ToString());

            GetDOMString(ElementList, stringBuilder, 1);

            return stringBuilder.ToString();
        }

        #endregion
        #region DOM ڿ μϱ - PrintDOMString()

        /// <summary>
        /// DOM ڿ μϱ
        /// </summary>
        public void PrintDOMString()
        {
            Console.WriteLine(GetDOMString());
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region DOM ڿ ϱ - GetDOMString(elementList, stringBuilder, level)

        /// <summary>
        /// DOM ڿ ϱ
        /// </summary>
        /// <param name="elementList">Ʈ Ʈ</param>
        /// <param name="stringBuilder">ڿ </param>
        /// <param name="level"></param>
        protected void GetDOMString(RTFDOMElementList elementList, StringBuilder stringBuilder, int level)
        {
            foreach(RTFDOMElement element in elementList)
            {
                stringBuilder.Append(Environment.NewLine);
                stringBuilder.Append(new string(' ' , level * 4));
                stringBuilder.Append(element.ToString());

                GetDOMString(element.ElementList, stringBuilder, level + 1);
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region   üũϱ - CheckLocked()

        /// <summary>
        ///   üũϱ
        /// </summary>
        private void CheckLocked()
        {
            if(this.locked)
            {
                throw new InvalidOperationException("Element locked");
            }
        }

        #endregion
    }
}