using System;
using System.ComponentModel;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM ʵ
    /// </summary>
    [Serializable]
    public class RTFDOMField : RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// RTF DOM ʵ ޼ҵ
        /// </summary>
        private RTFDOMFieldMethod method = RTFDOMFieldMethod.NONE;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ޼ҵ - Method

        /// <summary>
        /// ޼ҵ
        /// </summary>
        [DefaultValue(RTFDOMFieldMethod.NONE)]
        public RTFDOMFieldMethod Method
        {
            get
            {
                return this.method;
            }
            set
            {
                this.method = value;
            }
        }

        #endregion
        #region  - Instructions

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(null)]
        public string Instructions
        {
            get
            {
                foreach(RTFDOMElement element in ElementList)
                {
                    if(element is RTFDOMElementContainer)
                    {
                        RTFDOMElementContainer container = (RTFDOMElementContainer)element;

                        if(container.Name == RTFConstant.FLDINST)
                        {
                            return container.InnerText;
                        }
                    }
                }

                return null;
            }
        }

        #endregion
        #region  - Result

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(null)]
        public RTFDOMElementContainer Result
        {
            get
            {
                foreach(RTFDOMElement element in this.ElementList)
                {
                    if(element is RTFDOMElementContainer)
                    {
                        RTFDOMElementContainer container = (RTFDOMElementContainer)element;

                        if(container.Name == RTFConstant.FLDRSLT)
                        {
                            return container;
                        }
                    }
                }

                return null;
            }
        }

        #endregion
        #region  ڿ - ResultString

        /// <summary>
        ///  ڿ
        /// </summary>
        public string ResultString
        {
            get
            {
                RTFDOMElementContainer container = this.Result;

                if(container != null)
                {
                    return container.InnerText;
                }
                else
                {
                    return null;
                }
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDOMField()

        /// <summary>
        /// 
        /// </summary>
        public RTFDOMField()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            return "Field";
        }

        #endregion
    }
}