﻿using System;
using System.ComponentModel;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM 바닥글
    /// </summary>
    [Serializable]
    public class RTFDOMFooter : RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 스타일
        /// </summary>
        private HeaderFooterStyle style = HeaderFooterStyle.ALL_PAGES;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 스타일 - Style

        /// <summary>
        /// 스타일
        /// </summary>
        [DefaultValue(HeaderFooterStyle.ALL_PAGES)]
        public HeaderFooterStyle Style
        {
            get
            {
                return this.style;
            }
            set
            {
                this.style = value;
            }
        }

        #endregion
        #region 컨텐트 엘리먼트 소유 여부 - HasContentElement

        /// <summary>
        /// 컨텐트 엘리먼트 소유 여부
        /// </summary>
        public bool HasContentElement
        {
            get
            {
                return RTFUtility.HasContentElement(this);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            return $"Footer {Style}";
        }

        #endregion
    }
}