using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM ̹
    /// </summary>
    [Serializable]
    public class RTFDOMImage : RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ID
        /// </summary>
        private string id = null;

        /// <summary>
        /// 
        /// </summary>
        private byte[] data = null;

        /// <summary>
        ///  X
        /// </summary>
        private int scaleX = 100;

        /// <summary>
        ///  Y
        /// </summary>
        private int scaleY = 100;

        /// <summary>
        ///  ʺ
        /// </summary>
        private int desiredWidth = 0;

        /// <summary>
        ///  
        /// </summary>
        private int desiredHeight = 0;

        /// <summary>
        /// ʺ
        /// </summary>
        private int width = 0;

        /// <summary>
        /// 
        /// </summary>
        private int height = 0;

        /// <summary>
        /// RTF ׸ Ÿ
        /// </summary>
        private RTFPictureType pictureType = RTFPictureType.JPEG;

        /// <summary>
        /// RTF   
        /// </summary>
        private RTFDocumentFormatInfo format = new RTFDocumentFormatInfo();

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        [DefaultValue(null)]
        public string ID
        {
            get
            {
                return this.id;
            }
            set
            {
                this.id = value;
            }
        }

        #endregion
        #region  - Data

        /// <summary>
        /// 
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public byte[] Data
        {
            get
            {
                return this.data;
            }
            set
            {
                this.data = value;
            }
        }

        #endregion
        #region BASE64  - BASE64Data

        /// <summary>
        /// BASE64 
        /// </summary>
        [Browsable(false)]
        [XmlElement]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public string BASE64Data
        {
            get
            {
                if(this.data == null)
                {
                    return null;
                }
                else
                {
                    return Convert.ToBase64String(this.data);
                }
            }
            set
            {
                if(value != null && value.Length > 0)
                {
                    this.data = Convert.FromBase64String(value);
                }
                else
                {
                    this.data = null;
                }
            }
        }

        #endregion
        #region  X - ScaleX

        /// <summary>
        ///  X
        /// </summary>
        [DefaultValue(100)]
        public int ScaleX
        {
            get
            {
                return this.scaleX;
            }
            set
            {
                this.scaleX = value;
            }
        }

        #endregion
        #region  Y - ScaleY

        /// <summary>
        ///  Y
        /// </summary>
        [DefaultValue(100)]
        public int ScaleY
        {
            get
            {
                return this.scaleY;
            }
            set
            {
                this.scaleY = value;
            }
        }

        #endregion
        #region  ʺ - DesiredWidth

        /// <summary>
        ///  ʺ
        /// </summary>
        [DefaultValue(0)]
        public int DesiredWidth
        {
            get
            {
                return this.desiredWidth;
            }
            set
            {
                this.desiredWidth = value;
            }
        }

        #endregion
        #region   - DesiredHeight

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(0)]
        public int DesiredHeight
        {
            get
            {
                return this.desiredHeight;
            }
            set
            {
                this.desiredHeight = value;
            }
        }

        #endregion
        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        [DefaultValue(0)]
        public int Width
        {
            get
            {
                return this.width;
            }
            set
            {
                this.width = value;
            }
        }

        #endregion
        #region  - Height

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(0)]
        public int Height
        {
            get
            {
                return this.height;
            }
            set
            {
                this.height = value;
            }
        }

        #endregion
        #region ׸ Ÿ - PictureType

        /// <summary>
        /// ׸ Ÿ
        /// </summary>
        public RTFPictureType PictureType
        {
            get
            {
                return this.pictureType; 
            }
            set
            {
                this.pictureType = value; 
            }
        }

        #endregion
        #region    - Format

        /// <summary>
        ///   
        /// </summary>
        public RTFDocumentFormatInfo Format
        {
            get
            {
                return this.format;
            }
            set
            {
                this.format = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDOMImage()

        /// <summary>
        /// 
        /// </summary>
        public RTFDOMImage()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            string text = $"Image:{this.width}*{this.height}";

            if(this.data != null && this.data.Length > 0)
            {
                text = $"{text} {Convert.ToDouble(this.data.Length / 1024.0).ToString("0.00")}KB";
            }

            return text;
        }

        #endregion
    }
}