using System;
using System.ComponentModel;
using System.Xml.Serialization;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM ̺ 
    /// </summary>
    [Serializable]
    public class RTFDOMTableCell : RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 
        /// </summary>
        private int left = 0;

        /// <summary>
        /// ʺ
        /// </summary>
        private int width = 0;

        /// <summary>
        /// 
        /// </summary>
        private int height = 0;

        /// <summary>
        ///  
        /// </summary>
        private int rowSpan = 1;

        /// <summary>
        ///  
        /// </summary>
        private int columnSpan = 1;

        /// <summary>
        /// е 
        /// </summary>
        private int paddingLeft = int.MinValue;

        /// <summary>
        /// е 
        /// </summary>
        private int paddingTop = int.MinValue;

        /// <summary>
        /// е 
        /// </summary>
        private int paddingRight = int.MinValue;

        /// <summary>
        /// е Ʒ
        /// </summary>
        private int paddingBottom = int.MinValue;

        /// <summary>
        ///  
        /// </summary>
        private RTFVerticalAlignment verticalAlignment = RTFVerticalAlignment.Top;

        /// <summary>
        ///   
        /// </summary>
        private RTFDocumentFormatInfo format = new RTFDocumentFormatInfo();

        /// <summary>
        /// Ƽ  
        /// </summary>
        private bool multiline = true;

        /// <summary>
        /// ̵ 
        /// </summary>
        private RTFDOMTableCell overrideCell = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Left

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(0)]
        public int Left
        {
            get 
            {
                return this.left;
            }
            set
            {
                this.left = value;
            }
        }

        #endregion
        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        [DefaultValue(0)]
        public int Width
        {
            get
            {
                return this.width;
            }
            set
            {
                this.width = value;
            }
        }

        #endregion
        #region  - Height

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(0)]
        public int Height
        {
            get 
            {
                return this.height;
            }
            set 
            {
                this.height = value;
            }
        }

        #endregion

        #region   - RowSpan

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(1)]
        public int RowSpan
        {
            get
            {
                return this.rowSpan;
            }
            set
            {
                this.rowSpan = value;
            }
        }

        #endregion
        #region   - ColumnSpan

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(1)]
        public int ColumnSpan
        {
            get
            {
                return this.columnSpan;
            }
            set
            {
                this.columnSpan = value;
            }
        }

        #endregion

        #region е  - PaddingLeft

        /// <summary>
        /// е 
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingLeft
        {
            get
            {
                return this.paddingLeft;
            }
            set
            {
                this.paddingLeft = value;
            }
        }

        #endregion
        #region  е  - RuntimePaddingLeft

        /// <summary>
        ///  е 
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public int RuntimePaddingLeft
        {
            get
            {
                if(this.paddingLeft != int.MinValue)
                {
                    return this.paddingLeft;
                }
                else if(ParentElement != null)
                {
                    int padding = ((RTFDOMTableRow)ParentElement).PaddingLeft;

                    if(padding != int.MinValue)
                    {
                        return padding;
                    }
                }

                return 0;
            }
        }

        #endregion
        #region е  - PaddingTop

        /// <summary>
        /// е 
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingTop
        {
            get
            {
                return this.paddingTop;
            }
            set
            {
                this.paddingTop = value;
            }
        }

        #endregion
        #region  е  - RuntimePaddingTop

        /// <summary>
        ///  е 
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public int RuntimePaddingTop
        {
            get
            {
                if(this.paddingTop != int.MinValue)
                {
                    return this.paddingTop;
                }
                else if(ParentElement != null)
                {
                    int padding = ((RTFDOMTableRow)ParentElement).PaddingTop;

                    if(padding != int.MinValue)
                    {
                        return padding;
                    }
                }

                return 0;
            }
        }

        #endregion
        #region е  - PaddingRight

        /// <summary>
        /// е 
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingRight
        {
            get
            {
                return this.paddingRight;
            }
            set
            {
                this.paddingRight = value;
            }
        }

        #endregion
        #region  е  - RuntimePaddingRight

        /// <summary>
        ///  е 
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public int RuntimePaddingRight
        {
            get
            {
                if(this.paddingRight != int.MinValue)
                {
                    return this.paddingRight;
                }
                else if(ParentElement != null)
                {
                    int padding = ((RTFDOMTableRow)ParentElement).PaddingRight;

                    if(padding != int.MinValue)
                    {
                        return padding;
                    }
                }
                return 0;
            }
        }

        #endregion
        #region е Ʒ - PaddingBottom

        /// <summary>
        /// е Ʒ
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingBottom
        {
            get
            {
                return this.paddingBottom;
            }
            set
            {
                this.paddingBottom = value;
            }
        }

        #endregion
        #region  е Ʒ - RuntimePaddingBottom

        /// <summary>
        ///  е Ʒ
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public int RuntimePaddingBottom
        {
            get
            {
                if(this.paddingBottom != int.MinValue)
                {
                    return this.paddingBottom;
                }
                else if(ParentElement != null)
                {
                    int padding = ((RTFDOMTableRow)ParentElement).PaddingBottom;

                    if(padding != int.MinValue)
                    {
                        return padding;
                    }
                }

                return 0;
            }
        }

        #endregion

        #region   - VerticalAlignment

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(RTFVerticalAlignment.Top)]
        public RTFVerticalAlignment VerticalAlignment
        {
            get
            {
                return this.verticalAlignment;
            }
            set
            {
                this.verticalAlignment = value;
            }
        }

        #endregion
        #region    - Format

        /// <summary>
        ///   
        /// </summary>
        public RTFDocumentFormatInfo Format
        {
            get
            {
                return this.format;
            }
            set
            {
                this.format = value;
            }
        }

        #endregion
        #region Ƽ   - Multiline

        /// <summary>
        /// Ƽ  
        /// </summary>
        [DefaultValue(false)]
        public bool Multiline
        {
            get
            {
                return this.multiline;
            }
            set
            {
                this.multiline = value;
            }
        }

        #endregion
        #region ̵  - OverrideCell

        /// <summary>
        /// ̵ 
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        public RTFDOMTableCell OverrideCell
        {
            get
            {
                return this.overrideCell;
            }
            set
            {
                this.overrideCell = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDOMTableCell()

        /// <summary>
        /// 
        /// </summary>
        public RTFDOMTableCell()
        {
            this.format.BorderWidth = 1;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            if(this.overrideCell == null)
            {
                if(this.rowSpan != 1 || this.columnSpan != 1)
                {
                    return $"Cell: RowSpan:{this.rowSpan} ColSpan:{this.columnSpan} Width:{this.Width}";
                }
                else
                {
                    return $"Cell:Width:{this.Width}";
                }
            }
            else
            {
                return "Cell:Overrided";
            }
        }

        #endregion
    }
}