using System;
using System.ComponentModel;
using System.Collections;
using System.Xml.Serialization;

namespace TestLibrary
{
    /// <summary>
    /// RTF DOM ̺ 
    /// </summary>
    [Serializable]
    public class RTFDOMTableRow : RTFDOMElement
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ʺ
        /// </summary>
        private int width = 0;

        /// <summary>
        /// 
        /// </summary>
        private int height = 0;

        /// <summary>
        /// е 
        /// </summary>
        private int paddingLeft = int.MinValue;

        /// <summary>
        /// е 
        /// </summary>
        private int paddingTop = int.MinValue;

        /// <summary>
        /// е 
        /// </summary>
        private int paddingRight = int.MinValue;

        /// <summary>
        /// е Ʒ
        /// </summary>
        private int paddingBottom = int.MinValue;

        /// <summary>
        ///   Ʈ
        /// </summary>
        [NonSerialized]
        private ArrayList cellSettingList = new ArrayList();

        /// <summary>
        /// RTF   
        /// </summary>
        private RTFDocumentFormatInfo format = new RTFDocumentFormatInfo();

        /// <summary>
        /// 
        /// </summary>
        private int level = 1;

        /// <summary>
        ///  ε
        /// </summary>
        private int rowIndex = 0;

        /// <summary>
        ///   
        /// </summary>
        private bool isLastRow = false;

        /// <summary>
        /// Ӹ 
        /// </summary>
        private bool header = false;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ʺ - Width

        /// <summary>
        /// ʺ
        /// </summary>
        [DefaultValue(0)]
        public int Width
        {
            get
            {
                return this.width; 
            }
            set
            {
                this.width = value; 
            }
        }

        #endregion
        #region  - Height

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(0)]
        public int Height
        {
            get
            {
                return this.height;
            }
            set
            {
                this.height = value;
            }
        }

        #endregion
        #region е  - PaddingLeft

        /// <summary>
        /// е 
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingLeft
        {
            get
            {
                return this.paddingLeft;
            }
            set
            {
                this.paddingLeft = value;
            }
        }

        #endregion
        #region е  - PaddingTop

        /// <summary>
        /// е 
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingTop
        {
            get
            {
                return this.paddingTop;
            }
            set
            {
                this.paddingTop = value;
            }
        }

        #endregion
        #region е  - PaddingRight

        /// <summary>
        /// е 
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingRight
        {
            get
            {
                return this.paddingRight;
            }
            set
            {
                this.paddingRight = value;
            }
        }

        #endregion
        #region е Ʒ - PaddingBottom

        /// <summary>
        /// е Ʒ
        /// </summary>
        [DefaultValue(int.MinValue)]
        public int PaddingBottom
        {
            get
            {
                return this.paddingBottom;
            }
            set
            {
                this.paddingBottom = value;
            }
        }

        #endregion
        #region    - Format

        /// <summary>
        ///   
        /// </summary>
        public RTFDocumentFormatInfo Format
        {
            get
            {
                return this.format;
            }
            set
            {
                this.format = value;
            }
        }

        #endregion
        #region  - Level

        /// <summary>
        /// 
        /// </summary>
        [DefaultValue(1)]
        public int Level
        {
            get 
            {
                return this.level;
            }
            set
            {
                this.level = value;
            }
        }

        #endregion
        #region  ε - RowIndex

        /// <summary>
        ///  ε
        /// </summary>
        [DefaultValue(0)]
        internal int RowIndex
        {
            get
            {
                return this.rowIndex;
            }
            set
            {
                this.rowIndex = value;
            }
        }

        #endregion
        #region    - IsLastRow

        /// <summary>
        ///   
        /// </summary>
        [DefaultValue(false)]
        public bool IsLastRow
        {
            get
            {
                return this.isLastRow;
            }
            set
            {
                this.isLastRow = value;
            }
        }

        #endregion
        #region Ӹ  - Header

        /// <summary>
        /// Ӹ 
        /// </summary>
        [DefaultValue(false)]
        public bool Header
        {
            get
            {
                return this.header;
            }
            set
            {
                this.header = value;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region   Ʈ - CellSettingList

        /// <summary>
        ///   Ʈ
        /// </summary>
        [Browsable(false)]
        [XmlIgnore]
        internal ArrayList CellSettingList
        {
            get
            {
                return this.cellSettingList;
            }
            set
            {
                this.cellSettingList = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDOMTableRow()

        /// <summary>
        /// 
        /// </summary>
        public RTFDOMTableRow()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ڿ ϱ - ToString()

        /// <summary>
        /// ڿ ϱ
        /// </summary>
        /// <returns>ڿ</returns>
        public override string ToString()
        {
            return $"Row {this.rowIndex}";
        }

        #endregion
    }
}