using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Windows.Forms;

namespace TestLibrary
{
    /// <summary>
    /// RTF   
    /// </summary>
    [Serializable]
    public class RTFDocumentFormatInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Field

        /// <summary>
        /// Ƽ 
        /// </summary>
        /// <remarks>
        /// ⺻ RTF  ø 
        /// </remarks>
        public int NativeLevel = 0;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region Field

        /// <summary>
        /// ؽƮ б 
        /// </summary>
        internal bool ReadText = true;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// θ RTF   
        /// </summary>
        private RTFDocumentFormatInfo parent = null;

        /// <summary>
        ///  극ũ 
        /// </summary>
        private bool pageBreak = false;

        /// <summary>
        ///  ׵θ 
        /// </summary>
        private bool leftBorder = false;

        /// <summary>
        ///  ׵θ 
        /// </summary>
        private bool topBorder = false;

        /// <summary>
        ///  ׵θ
        /// </summary>
        private bool rightBorder = false;

        /// <summary>
        /// Ʒ ׵θ
        /// </summary>
        private bool bottomBorder = false;

        /// <summary>
        /// ׵θ β 
        /// </summary>
        private bool borderThickness = false;

        /// <summary>
        /// ׵θ ʺ
        /// </summary>
        private int borderWidth = 0;

        /// <summary>
        /// ׵θ 
        /// </summary>
        private int borderSpacing = 0;

        /// <summary>
        /// ׵θ 
        /// </summary>
        private Color borderColor = Color.Black;

        /// <summary>
        /// ׵θ Ÿ
        /// </summary>
        private DashStyle borderStyle = DashStyle.Solid;

        /// <summary>
        /// Ƽ  
        /// </summary>
        private bool multiLine = false;

        /// <summary>
        /// Ƽ   
        /// </summary>
        private bool multiLineSpacing = false;

        /// <summary>
        ///  
        /// </summary>
        private int lineSpacing = 0;

        /// <summary>
        ///   
        /// </summary>
        private int spacingBeforeParagraph = 0;

        /// <summary>
        ///   
        /// </summary>
        private int spacingAfterParagraph = 0;

        /// <summary>
        ///  ù°  鿩
        /// </summary>
        private int paragraphFirstLineIndent = 0;

        /// <summary>
        /// ǥ  ʺ
        /// </summary>
        private int standardTabWidth = 100;

        /// <summary>
        ///  鿩
        /// </summary>
        private int leftIndent = 0;

        /// <summary>
        /// ؽƮ 
        /// </summary>
        private RTFTextAlignment textAlignment = RTFTextAlignment.LEFT;

        /// <summary>
        ///  
        /// </summary>
        private int characterSpacing = 0;

        /// <summary>
        /// Ʈ
        /// </summary>
        private string fontName = Control.DefaultFont.Name;

        /// <summary>
        /// Ʈ ũ
        /// </summary>
        private float fontSize = 12f;

        /// <summary>
        /// ü 
        /// </summary>
        private bool bold = false;

        /// <summary>
        /// Ÿü 
        /// </summary>
        private bool italic = false;

        /// <summary>
        ///  
        /// </summary>
        private bool underline = false;

        /// <summary>
        /// Ʈũ ƿ 
        /// </summary>
        private bool strikeout = false;

        /// <summary>
        ///  
        /// </summary>
        private bool hidden = false;

        /// <summary>
        /// ؽƮ 
        /// </summary>
        private Color textColor = Color.Black;

        /// <summary>
        ///  
        /// </summary>
        private Color backgroundColor = Color.Empty;

        /// <summary>
        /// ũ
        /// </summary>
        private string link = null;

        /// <summary>
        ///  ÷ 
        /// </summary>
        private bool superscript = false;

        /// <summary>
        /// Ʒ ÷ 
        /// </summary>
        private bool subscript = false;

        /// <summary>
        ///  ID
        /// </summary>
        private int listID = -1;

        /// <summary>
        ///   
        /// </summary>
        private bool noWrap = true;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region θ RTF    - Parent

        /// <summary>
        /// θ RTF   
        /// </summary>
        [Browsable(false)]
        public RTFDocumentFormatInfo Parent
        {
            get
            {
                return this.parent;
            }
        }

        #endregion
        #region  극ũ  - PageBreak

        /// <summary>
        ///  극ũ 
        /// </summary>
        [DefaultValue(false)]
        public bool PageBreak
        {
            get
            {
                return this.pageBreak;
            }
            set
            {
                this.pageBreak = value;
            }
        }

        #endregion
        #region  ׵θ  - LeftBorder

        /// <summary>
        ///  ׵θ 
        /// </summary>
        [DefaultValue(false)]
        public bool LeftBorder
        {
            get
            {
                return this.leftBorder;
            }
            set
            {
                this.leftBorder = value;
            }
        }

        #endregion
        #region  ׵θ  - TopBorder

        /// <summary>
        ///  ׵θ 
        /// </summary>
        [DefaultValue(false)]
        public bool TopBorder
        {
            get
            {
                return this.topBorder;
            }
            set
            {
                this.topBorder = value;
            }
        }

        #endregion
        #region  ׵θ - RightBorder

        /// <summary>
        ///  ׵θ
        /// </summary>
        [DefaultValue(false)]
        public bool RightBorder
        {
            get
            {
                return this.rightBorder;
            }
            set
            {
                this.rightBorder = value;
            }
        }

        #endregion
        #region Ʒ ׵θ - BottomBorder

        /// <summary>
        /// Ʒ ׵θ
        /// </summary>
        [DefaultValue(false)]
        public bool BottomBorder
        {
            get
            {
                return this.bottomBorder;
            }
            set
            {
                this.bottomBorder = value;
            }
        }

        #endregion
        #region ׵θ β  - BorderThickness

        /// <summary>
        /// ׵θ β 
        /// </summary>
        [DefaultValue(false)]
        public bool BorderThickness
        {
            get
            {
                return this.borderThickness; 
            }
            set 
            {
                this.borderThickness = value;
            }
        }

        #endregion
        #region ׵θ ʺ - BorderWidth

        /// <summary>
        /// ׵θ ʺ
        /// </summary>
        [DefaultValue(0)]
        public int BorderWidth
        {
            get
            {
                return this.borderWidth;
            }
            set
            {
                this.borderWidth = value;
            }
        }

        #endregion
        #region ׵θ  - BorderSpacing

        /// <summary>
        /// ׵θ 
        /// </summary>
        [DefaultValue(0)]
        public int BorderSpacing
        {
            get
            {
                return this.borderSpacing; 
            }
            set
            {
                this.borderSpacing = value; 
            }
        }

        #endregion
        #region ׵θ  - BorderColor

        /// <summary>
        /// ׵θ 
        /// </summary>
        [DefaultValue(typeof(Color), "Black")]
        public Color BorderColor
        {
            get
            {
                return this.borderColor;
            }
            set
            {
                this.borderColor = value;
            }
        }

        #endregion
        #region ׵θ Ÿ - BorderStyle

        /// <summary>
        /// ׵θ Ÿ
        /// </summary>
        [DefaultValue(DashStyle.Solid)]
        public DashStyle BorderStyle
        {
            get 
            {
                return this.borderStyle;
            }
            set
            {
                this.borderStyle = value;
            }
        }

        #endregion
        #region Ƽ   - MultiLine

        /// <summary>
        /// Ƽ  
        /// </summary>
        [DefaultValue(false)]
        public bool MultiLine
        {
            get
            {
                return this.multiLine;
            }
            set
            {
                this.multiLine = value;
            }
        }

        #endregion
        #region Ƽ    - MultiLineSpacing

        /// <summary>
        /// Ƽ   
        /// </summary>
        [DefaultValue(false)]
        public bool MultiLineSpacing
        {
            get
            {
                return this.multiLineSpacing; 
            }
            set
            {
                this.multiLineSpacing = value; 
            }
        }

        #endregion
        #region   - LineSpacing

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(0)]
        public int LineSpacing
        {
            get
            {
                return this.lineSpacing;
            }
            set
            {
                this.lineSpacing = value;
            }
        }

        #endregion
        #region    - SpacingBeforeParagraph

        /// <summary>
        ///   
        /// </summary>
        [DefaultValue(0)]
        public int SpacingBeforeParagraph
        {
            get
            {
                return this.spacingBeforeParagraph;
            }
            set
            {
                this.spacingBeforeParagraph = value;
            }
        }

        #endregion
        #region    - SpacingAfterParagraph

        /// <summary>
        ///   
        /// </summary>
        [DefaultValue(0)]
        public int SpacingAfterParagraph
        {
            get
            {
                return this.spacingAfterParagraph;
            }
            set
            {
                this.spacingAfterParagraph = value;
            }
        }

        #endregion
        #region  ù°  鿩 - ParagraphFirstLineIndent

        /// <summary>
        ///  ù°  鿩
        /// </summary>
        [DefaultValue(0)]
        public int ParagraphFirstLineIndent
        {
            get
            {
                return this.paragraphFirstLineIndent;
            }
            set
            {
                this.paragraphFirstLineIndent = value;
            }
        }

        #endregion
        #region ǥ  ʺ - StandTabWidth

        /// <summary>
        /// ǥ  ʺ
        /// </summary>
        [DefaultValue(100)]
        public int StandTabWidth
        {
            get
            {
                return this.standardTabWidth;
            }
            set
            {
                this.standardTabWidth = value;
            }
        }

        #endregion
        #region  鿩 - LeftIndent

        /// <summary>
        ///  鿩
        /// </summary>
        [DefaultValue(0)]
        public int LeftIndent
        {
            get
            {
                return this.leftIndent;
            }
            set
            {
                this.leftIndent = value;
            }
        }

        #endregion
        #region ؽƮ  - TextAlignment

        /// <summary>
        /// ؽƮ 
        /// </summary>
        [DefaultValue(RTFTextAlignment.LEFT)]
        public RTFTextAlignment TextAlignment
        {
            get
            {
                return this.textAlignment;
            }
            set
            {
                this.textAlignment = value;
            }
        }

        #endregion
        #region   - CharacterSpacing

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(0)]
        public int CharacterSpacing
        {
            get
            {
                return this.characterSpacing;
            }
            set
            {
                this.characterSpacing = value;
            }
        }

        #endregion
        #region Ʈ - Font

        /// <summary>
        /// Ʈ
        /// </summary>
        [Browsable(false)]
        public Font Font
        {
            set
            {
                if(value != null)
                {
                    FontName  = value.Name;
                    FontSize  = value.Size;
                    Bold      = value.Bold;
                    Italic    = value.Italic;
                    Underline = value.Underline;
                    Strikeout = value.Strikeout;
                }
            }
        }

        #endregion
        #region Ʈ - FontName

        /// <summary>
        /// Ʈ
        /// </summary>
        public string FontName
        {
            get
            {
                return this.fontName;
            }
            set
            {
                this.fontName = value;
            }
        }

        #endregion
        #region Ʈ ũ - FontSize

        /// <summary>
        /// Ʈ ũ
        /// </summary>
        [DefaultValue(12f)]
        public float FontSize
        {
            get
            {
                return this.fontSize;
            }
            set
            {
                this.fontSize = value;
            }
        }

        #endregion
        #region ü  - Bold

        /// <summary>
        /// ü 
        /// </summary>
        [DefaultValue(false)]
        public bool Bold
        {
            get
            {
                return this.bold;
            }
            set
            {
                this.bold = value;
            }
        }

        #endregion
        #region Ÿü  - Italic

        /// <summary>
        /// Ÿü 
        /// </summary>
        [DefaultValue(false)]
        public bool Italic
        {
            get
            {
                return this.italic;
            }
            set
            {
                this.italic = value;
            }
        }

        #endregion
        #region   - Underline

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(false)]
        public bool Underline
        {
            get
            {
                return this.underline;
            }
            set
            {
                this.underline = value;
            }
        }

        #endregion
        #region Ʈũ ƿ  - Strikeout

        /// <summary>
        /// Ʈũ ƿ 
        /// </summary>
        [DefaultValue(false)]
        public bool Strikeout
        {
            get
            {
                return this.strikeout;
            }
            set
            {
                this.strikeout = value;
            }
        }

        #endregion
        #region  ÷  - Superscript

        /// <summary>
        ///  ÷ 
        /// </summary>
        [DefaultValue(false)]
        public bool Superscript
        {
            get
            {
                return this.superscript;
            }
            set
            {
                this.superscript = value;

                if(this.superscript)
                {
                    this.subscript = false;
                }
            }
        }

        #endregion
        #region Ʒ ÷  - Subscript

        /// <summary>
        /// Ʒ ÷ 
        /// </summary>
        [DefaultValue(false)]
        public bool Subscript
        {
            get
            {
                return this.subscript;
            }
            set
            {
                this.subscript = value;

                if(this.subscript)
                {
                    this.superscript = false;
                }
            }
        }

        #endregion
        #region   - Hidden

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(false)]
        public bool Hidden
        {
            get
            {
                return this.hidden;
            }
            set
            {
                this.hidden = value;
            }
        }

        #endregion
        #region ؽƮ  - TextColor

        /// <summary>
        /// ؽƮ 
        /// </summary>
        [DefaultValue(typeof(Color), "Black")]
        public Color TextColor
        {
            get
            {
                return this.textColor;
            }
            set
            {
                this.textColor = value;
            }
        }

        #endregion
        #region   - BackgroundColor

        /// <summary>
        ///  
        /// </summary>
        [DefaultValue(typeof(Color), "Empty")]
        public Color BackgroundColor
        {
            get
            {
                return this.backgroundColor;
            }
            set
            {
                this.backgroundColor = value;
            }
        }

        #endregion
        #region ũ - Link

        /// <summary>
        /// ũ
        /// </summary>
        [DefaultValue(null)]
        public string Link
        {
            get
            {
                return this.link;
            }
            set
            {
                this.link = value;
            }
        }

        #endregion
        #region  ID - ListID

        /// <summary>
        ///  ID
        /// </summary>
        public int ListID
        {
            get
            {
                return this.listID;
            }
            set
            {
                this.listID = value;
            }
        }

        #endregion
        #region    - NoWrap

        /// <summary>
        ///   
        /// </summary>
        [DefaultValue(true)]
        public bool NoWrap
        {
            get
            {
                return this.noWrap;
            }
            set
            {
                this.noWrap = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDocumentFormatInfo()

        /// <summary>
        /// 
        /// </summary>
        public RTFDocumentFormatInfo()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ - Clone()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF   </returns>
        public RTFDocumentFormatInfo Clone()
        {
            return (RTFDocumentFormatInfo)MemberwiseClone();
        }

        #endregion
        #region    ϱ - EqualsSettings(source)

        /// <summary>
        ///    ϱ
        /// </summary>
        /// <param name="source">ҽ RTF   </param>
        /// <returns>  </returns>
        public bool EqualsSettings(RTFDocumentFormatInfo source)
        {
            if(source == this)
            {
                return true;
            }

            if(source == null)
            {
                return false;
            }

            if(TextAlignment != source.TextAlignment)
            {
                return false;
            }

            if(BackgroundColor != source.BackgroundColor)
            {
                return false;
            }

            if(Bold != source.Bold)
            {
                return false;
            }

            if(BorderColor != source.BorderColor)
            {
                return false;
            }

            if(LeftBorder != source.LeftBorder)
            {
                return false;
            }

            if(TopBorder != source.TopBorder)
            {
                return false;
            }

            if(RightBorder != source.RightBorder)
            {
                return false;
            }

            if(BottomBorder != source.BottomBorder)
            {
                return false;
            }

            if(BorderStyle != source.BorderStyle)
            {
                return false;
            }

            if(BorderThickness != source.BorderThickness)
            {
                return false;
            }

            if(BorderSpacing != source.BorderSpacing)
            {
                return false;
            }

            if(ListID != source.ListID)
            {
                return false;
            }

            if(FontName != source.FontName)
            {
                return false;
            }

            if(FontSize != source.FontSize)
            {
                return false;
            }

            if(Italic != source.Italic)
            {
                return false;
            }

            if(Hidden != source.Hidden)
            {
                return false;
            }

            if(LeftIndent != source.LeftIndent)
            {
                return false;
            }

            if(LineSpacing != source.LineSpacing)
            {
                return false;
            }

            if(Link != source.Link)
            {
                return false;
            }

            if(MultiLine != source.MultiLine)
            {
                return false;
            }

            if(NoWrap != source.NoWrap)
            {
                return false;
            }

            if(ParagraphFirstLineIndent != source.ParagraphFirstLineIndent)
            {
                return false;
            }

            if(CharacterSpacing != source.CharacterSpacing)
            {
                return false;
            }

            if(StandTabWidth != source.StandTabWidth)
            {
                return false;
            }

            if(Strikeout != source.Strikeout)
            {
                return false;
            }

            if(Subscript != source.Subscript)
            {
                return false;
            }

            if(Superscript != source.Superscript)
            {
                return false;
            }

            if(TextColor != source.TextColor)
            {
                return false;
            }

            if(Underline != source.Underline)
            {
                return false;
            }

            if(ReadText != source.ReadText)
            {
                return false;
            }

            return true;
        }

        #endregion
        #region  ϱ - SetAlignment(alignment)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="alignment"></param>
        public void SetAlignment(StringAlignment alignment)
        {
            if(alignment == StringAlignment.Center)
            {
                this.TextAlignment = RTFTextAlignment.CENTER;
            }
            else if(alignment == StringAlignment.Far)
            {
                this.TextAlignment = RTFTextAlignment.RIGHT;
            }
            else
            {
                this.TextAlignment = RTFTextAlignment.LEFT;
            }
        }

        #endregion
        #region ϱ - Reset()

        /// <summary>
        /// ϱ
        /// </summary>
        public void Reset()
        {
            ParagraphFirstLineIndent = 0;
            LeftIndent               = 0;
            LeftIndent               = 0;
            CharacterSpacing         = 0;
            LineSpacing              = 0;
            MultiLineSpacing         = false;
            SpacingBeforeParagraph   = 0;
            SpacingAfterParagraph    = 0;
            TextAlignment            = 0;
            FontName                 = Control.DefaultFont.Name;
            FontSize                 = 12;
            Bold                     = false;
            Italic                   = false;
            Underline                = false;
            Strikeout                = false;
            TextColor                = Color.Black;
            BackgroundColor          = Color.Empty;
            Link                     = null;
            Subscript                = false;
            Superscript              = false;
            ListID                   = -1;
            MultiLine                = true;
            NoWrap                   = true;
            LeftBorder               = false;
            TopBorder                = false;
            RightBorder              = false;
            BottomBorder             = false;
            BorderStyle              = DashStyle.Solid;
            BorderSpacing            = 0;
            BorderThickness          = false;
            BorderColor              = Color.Black;
            ReadText                 = true;
            NativeLevel              = 0;
            Hidden                   = false;
        }

        #endregion
        #region  ϱ - ResetParagraph()

        /// <summary>
        ///  ϱ
        /// </summary>
        public void ResetParagraph()
        {
            ParagraphFirstLineIndent = 0;
            TextAlignment            = 0;
            ListID                   = -1;
            LeftIndent               = 0;
            LineSpacing              = 0;
            PageBreak                = false;
            LeftBorder               = false;
            TopBorder                = false;
            RightBorder              = false;
            BottomBorder             = false;
            BorderStyle              = DashStyle.Solid;
            BorderSpacing            = 0;
            BorderThickness          = false;
            BorderColor              = Color.Black ;
            MultiLineSpacing         = false;
            SpacingBeforeParagraph   = 0;
            SpacingAfterParagraph    = 0;
        }

        #endregion
        #region ؽƮ ϱ - ResetText()

        /// <summary>
        /// ؽƮ ϱ
        /// </summary>
        public void ResetText()
        {
            FontName        = Control.DefaultFont.Name;
            FontSize        = 12;
            Bold            = false;
            Italic          = false;
            Underline       = false;
            Strikeout       = false;
            TextColor       = Color.Black;
            BackgroundColor = Color.Empty;
            Subscript       = false;
            Superscript     = false;
            MultiLine       = true;
            Hidden          = false;
            LeftBorder      = false;
            TopBorder       = false;
            RightBorder     = false;
            BottomBorder    = false;
            BorderStyle     = DashStyle.Solid;
            BorderSpacing   = 0;
            BorderThickness = false;
            BorderColor     = Color.Black;
        }

        #endregion
    }
}