using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Diagnostics;

namespace TestLibrary
{
    /// <summary>
    /// RTF  
    /// </summary>
    [Serializable]
    [DebuggerTypeProxy(typeof(RTFInstanceDebugView))]
    public class RTFDocumentInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// ųʸ
        /// </summary>
        private StringDictionary dictionary = new StringDictionary();

        /// <summary>
        ///  ð
        /// </summary>
        private DateTime createTime = DateTime.Now;

        /// <summary>
        ///  ð
        /// </summary>
        private DateTime updateTime = DateTime.Now;

        /// <summary>
        /// μ ð
        /// </summary>
        private DateTime printTime = DateTime.Now;

        /// <summary>
        ///  ð
        /// </summary>
        private DateTime backupTime = DateTime.Now;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Title

        /// <summary>
        /// 
        /// </summary>
        public string Title
        {
            get
            {
                return this.dictionary["title"];
            }
            set
            {
                this.dictionary["title"] = value;
            }
        }

        #endregion
        #region  - Subject

        /// <summary>
        /// 
        /// </summary>
        public string Subject
        {
            get
            {
                return this.dictionary["subject"];
            }
            set
            {
                this.dictionary["subject"] = value;
            }
        }

        #endregion
        #region  - Author

        /// <summary>
        /// 
        /// </summary>
        public string Author
        {
            get
            {
                return this.dictionary["author"];
            }
            set
            {
                this.dictionary["author"] = value;
            }
        }

        #endregion
        #region  - Manager

        /// <summary>
        /// 
        /// </summary>
        public string Manager
        {
            get
            {
                return this.dictionary["manager"];
            }
            set
            {
                this.dictionary["manager"] = value;
            }
        }

        #endregion
        #region ȸ - Company

        /// <summary>
        /// ȸ
        /// </summary>
        public string Company
        {
            get
            {
                return this.dictionary["company"];
            }
            set
            {
                this.dictionary["company"] = value;
            }
        }

        #endregion
        #region  - Operator

        /// <summary>
        /// 
        /// </summary>
        public string Operator
        {
            get
            {
                return this.dictionary["operator"];
            }
            set
            {
                this.dictionary["operator"] = value;
            }
        }

        #endregion
        #region īװ - Category

        /// <summary>
        /// īװ
        /// </summary>
        public string Category
        {
            get
            {
                return this.dictionary["category"];
            }
            set
            {
                this.dictionary["categroy"] = value;
            }
        }

        #endregion
        #region Ű - Keywords

        /// <summary>
        /// Ű
        /// </summary>
        public string Keywords
        {
            get
            {
                return this.dictionary["keywords"];
            }
            set
            {
                this.dictionary["keywords"] = value;
            }
        }

        #endregion
        #region ּ - Comment

        /// <summary>
        /// ּ
        /// </summary>
        public string Comment
        {
            get
            {
                return this.dictionary["comment"];
            }
            set
            {
                this.dictionary["comment"] = value;
            }
        }

        #endregion
        #region  ּ - DocumentCommenct

        /// <summary>
        ///  ּ
        /// </summary>
        public string DocumentCommenct
        {
            get
            {
                return this.dictionary["doccomm"];
            }
            set
            {
                this.dictionary["doccomm"] = value;
            }
        }

        #endregion
        #region ⺻ ۸ũ - BaseHyperlink

        /// <summary>
        /// ⺻ ۸ũ
        /// </summary>
        public string BaseHyperlink
        {
            get
            {
                return this.dictionary["hlinkbase"];
            }
            set
            {
                this.dictionary["hlinkbase"] = value;
            }
        }

        #endregion
        #region ü   īƮ - TotalEditMinuteCount

        /// <summary>
        /// ü   īƮ
        /// </summary>
        public int TotalEditMinuteCount
        {
            get 
            {
                if(this.dictionary.ContainsKey("edmins"))
                {
                    string totalEditMinuteCountString = Convert.ToString(this.dictionary["edmins"]);

                    int result;

                    if(int.TryParse(totalEditMinuteCountString, out result))
                    {
                        return result;
                    }
                }

                return 0;
            }
            set
            {
                this.dictionary["edmins"] = value.ToString();
            }
        }

        #endregion
        #region  - Version

        /// <summary>
        /// 
        /// </summary>
        public string Version
        {
            get
            {
                return this.dictionary["vern"];
            }
            set
            {
                this.dictionary["vern"] = value;
            }
        }

        #endregion
        #region  īƮ - PageCount

        /// <summary>
        ///  īƮ
        /// </summary>
        public string PageCount
        {
            get
            {
                return this.dictionary["nofpages"];
            }
            set
            {
                this.dictionary["nofpages"] = value;
            }
        }

        #endregion
        #region ܾ īƮ - WordCount

        /// <summary>
        /// ܾ īƮ
        /// </summary>
        public string WordCount
        {
            get
            {
                return this.dictionary["nofwords"];
            }
            set
            {
                this.dictionary["nofwords"] = value;
            }
        }

        #endregion
        #region  īƮ ( ڿ ) - CharacterCount

        /// <summary>
        ///  īƮ ( ڿ )
        /// </summary>
        public string CharacterCount
        {
            get
            {
                return this.dictionary["nofchars"];
            }
            set
            {
                this.dictionary["nofchars"] = value;
            }
        }

        #endregion
        #region  īƮ ( ڿ ) - CharacterCountExcludingWhiteSpace

        /// <summary>
        ///  īƮ ( ڿ )
        /// </summary>
        public string CharacterCountExcludingWhiteSpace
        {
            get
            {
                return this.dictionary["nofcharsws"];
            }
            set
            {
                this.dictionary["nofcharsws"] = value;
            }
        }

        #endregion
        #region ID - ID

        /// <summary>
        /// ID
        /// </summary>
        public string ID
        {
            get
            {
                return this.dictionary["id"];
            }
            set
            {
                this.dictionary["id"] = value;
            }
        }

        #endregion
        #region  ð - CreateTime

        /// <summary>
        ///  ð
        /// </summary>
        public DateTime CreateTime
        {
            get
            {
                return this.createTime;
            }
            set
            {
                this.createTime = value;
            }
        }

        #endregion
        #region  ð - UpdateTime

        /// <summary>
        ///  ð
        /// </summary>
        public DateTime UpdateTime
        {
            get
            {
                return this.updateTime;
            }
            set
            {
                this.updateTime = value;
            }
        }

        #endregion
        #region μ ð - PrintTime

        /// <summary>
        /// μ ð
        /// </summary>
        public DateTime PrintTime
        {
            get
            {
                return this.printTime;
            }
            set
            {
                this.printTime = value;
            }
        }

        #endregion
        #region  ð - BackupTime

        /// <summary>
        ///  ð
        /// </summary>
        public DateTime BackupTime
        {
            get
            {
                return this.backupTime;
            }
            set
            {
                this.backupTime = value;
            }
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region ׸ 迭 - ItemArray

        /// <summary>
        /// ׸ 迭
        /// </summary>
        internal string[] ItemArray
        {
            get
            {
                List<string> list = new List<string>();

                foreach(string key in this.dictionary.Keys)
                {
                    list.Add(key + "=" + this.dictionary[key]);
                }

                list.Add("Creatim=" + CreateTime.ToString("yyyy-MM-dd HH:mm:ss"));
                list.Add("Revtim="  + UpdateTime.ToString("yyyy-MM-dd HH:mm:ss"));
                list.Add("Printim=" + PrintTime.ToString ("yyyy-MM-dd HH:mm:ss"));
                list.Add("Buptim="  + BackupTime.ToString("yyyy-MM-dd HH:mm:ss"));

                return list.ToArray();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  ϱ - SetInfo(name , value)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="name">Ī</param>
        /// <param name="value"></param>
        public void SetInfo(string name , string value)
        {
            this.dictionary[name] = value;
        }

        #endregion
        #region  ϱ - GetInfo(name)

        /// <summary>
        ///  ϱ
        /// </summary>
        /// <param name="name">Ī</param>
        /// <returns></returns>
        public string GetInfo(string name)
        {
            return this.dictionary[name];
        }

        #endregion
        #region  - Write(writer)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="writer">RTF </param>
        public void Write(RTFWriter writer)
        {
            writer.WriteStartGroup();

            writer.WriteKeyword("info");

            foreach(string key in this.dictionary.Keys)
            {
                writer.WriteStartGroup();

                if
                (   key == "edmins"     ||
                    key == "vern"       ||
                    key == "nofpages"   ||
                    key == "nofwords"   ||
                    key == "nofchars"   ||
                    key == "nofcharsws" ||
                    key == "id"
                )
                {
                    writer.WriteKeyword(key + this.dictionary[key]);
                }
                else
                {
                    writer.WriteKeyword(key);

                    writer.WriteText(this.dictionary[key]);
                }

                writer.WriteEndGroup();
            }

            writer.WriteStartGroup();

            WriteTime(writer, "creatim", this.createTime);
            WriteTime(writer, "revtim" , this.updateTime);
            WriteTime(writer, "printim", this.printTime );
            WriteTime(writer, "buptim" , this.backupTime);

            writer.WriteEndGroup();
        }

        #endregion
        #region  - Clear()

        /// <summary>
        /// 
        /// </summary>
        public void Clear()
        {
            this.dictionary.Clear();

            DateTime currentTime = DateTime.Now;

            this.createTime = currentTime;
            this.updateTime = currentTime;
            this.printTime  = currentTime;
            this.backupTime = currentTime;
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region ð  - WriteTime(writer, name, value)

        /// <summary>
        /// ð 
        /// </summary>
        /// <param name="writer">RTF </param>
        /// <param name="name">Ī</param>
        /// <param name="value"></param>
        private void WriteTime(RTFWriter writer, string name, DateTime value)
        {
            writer.WriteStartGroup();

            writer.WriteKeyword(name);

            writer.WriteKeyword("yr"  + value.Year  );
            writer.WriteKeyword("mo"  + value.Month );
            writer.WriteKeyword("dy"  + value.Day   );
            writer.WriteKeyword("hr"  + value.Hour  );
            writer.WriteKeyword("min" + value.Minute);
            writer.WriteKeyword("sec" + value.Second);

            writer.WriteEndGroup();
        }

        #endregion
    }
}