using System;
using System.Collections ;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.IO;
using System.Text;
using System.Windows.Forms;

namespace TestLibrary
{
    /// <summary>
    /// RTF  
    /// </summary>
    public class RTFDocumentWriter
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// RTF 
        /// </summary>
        private RTFWriter writer = null;

        /// <summary>
        ///   ؽ ̺
        /// </summary>
        private Hashtable documentInfoHashtable = new Hashtable();

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        private RTFFontTable fontTable = new RTFFontTable();

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        private RTFListTable listTable = new RTFListTable();

        /// <summary>
        /// Ʈ ̵ ̺
        /// </summary>
        private RTFListOverrideTable listOverrideTable = new RTFListOverrideTable();

        /// <summary>
        ///  ̺
        /// </summary>
        private RTFColorTable colorTable = new RTFColorTable();

        /// <summary>
        ///    
        /// </summary>
        private bool collectDocumentInfo = true;

        /// <summary>
        ///  
        /// </summary>
        private bool debugMode = true;

        /// <summary>
        ///   
        /// </summary>
        private RTFDocumentFormatInfo lastParagraphInfo = null;

        /// <summary>
        /// ù°  
        /// </summary>
        private bool firstParagraph = true;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region RTF  - Writer

        /// <summary>
        /// RTF 
        /// </summary>
        public RTFWriter Writer
        {
            get
            {
                return this.writer;
            }
            set
            {
                this.writer = value;
            }
        }

        #endregion
        #region   ؽ ̺ - DocumentInfoHashtable

        /// <summary>
        ///   ؽ ̺
        /// </summary>
        public Hashtable DocumentInfoHashtable
        {
            get
            {
                return this.documentInfoHashtable;
            }
        }

        #endregion
        #region Ʈ ̺ - FontTable

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        public RTFFontTable FontTable
        {
            get
            {
                return this.fontTable;
            }
        }

        #endregion
        #region Ʈ ̺ - ListTable

        /// <summary>
        /// Ʈ ̺
        /// </summary>
        public RTFListTable ListTable
        {
            get
            {
                return this.listTable;
            }
            set
            {
                this.listTable = value;
            }
        }

        #endregion
        #region Ʈ ̵ ̺ - ListOverrideTable

        /// <summary>
        /// Ʈ ̵ ̺
        /// </summary>
        public RTFListOverrideTable ListOverrideTable
        {
            get
            {
                return this.listOverrideTable;
            }
            set
            {
                this.listOverrideTable = value;
            }
        }

        #endregion
        #region  ̺ - ColorTable

        /// <summary>
        ///  ̺
        /// </summary>
        public RTFColorTable ColorTable
        {
            get
            {
                return this.colorTable;
            }
        }

        #endregion
        #region     - CollectDocumentInfo

        /// <summary>
        ///    
        /// </summary>
        public bool CollectDocumentInfo
        {
            get
            {
                return this.collectDocumentInfo;
            }
            set
            {
                this.collectDocumentInfo = value;
            }
        }

        #endregion
        #region ׷  - GroupLevel

        /// <summary>
        /// ׷ 
        /// </summary>
        public int GroupLevel
        {
            get
            {
                return this.writer.GroupLevel;
            }
        }

        #endregion
        #region   - DebugMode

        /// <summary>
        ///  
        /// </summary>
        public bool DebugMode
        {
            get
            {
                return this.debugMode;
            }
            set
            {
                this.debugMode = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFDocumentWriter()

        /// <summary>
        /// 
        /// </summary>
        public RTFDocumentWriter()
        {
            this.colorTable.CheckValueExistWhenAdd = true;
        }

        #endregion
        #region  - RTFDocumentWriter(writer)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="writer">ؽƮ </param>
        public RTFDocumentWriter(TextWriter writer)
        {
            this.colorTable.CheckValueExistWhenAdd = true;

            Open(writer);
        }

        #endregion
        #region  - RTFDocumentWriter(filePath)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="filePath"> </param>
        public RTFDocumentWriter(string filePath)
        {
            this.colorTable.CheckValueExistWhenAdd = true;

            Open(filePath);
        }

        #endregion
        #region  - RTFDocumentWriter(stream)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="stream">Ʈ</param>
        public RTFDocumentWriter(Stream stream)
        {
            this.colorTable.CheckValueExistWhenAdd = true;

            StreamWriter writer = new StreamWriter(stream, Encoding.ASCII);

            Open(writer);
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - Open(writer)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="writer">ؽƮ </param>
        /// <returns>ó </returns>
        public virtual bool Open(TextWriter writer)
        {
            this.writer = new RTFWriter(writer);

            this.writer.Encoding = Encoding.GetEncoding(936);
            this.writer.Indent   = false;

            return true;
        }

        #endregion
        #region  - Open(filePath)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="filePath"> </param>
        /// <returns>ó </returns>
        public virtual bool Open(string filePath)
        {
            this.writer = new RTFWriter(filePath);

            this.writer.Encoding = Encoding.GetEncoding(936);
            this.writer.Indent   = false;

            return true;
        }

        #endregion
        #region ׷   - WriteStartGroup()

        /// <summary>
        /// ׷  
        /// </summary>
        public void WriteStartGroup()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteStartGroup();
            }
        }

        #endregion
        #region ׷   - WriteEndGroup()

        /// <summary>
        /// ׷  
        /// </summary>
        public void WriteEndGroup()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteEndGroup();
            }
        }

        #endregion
        #region Ű  - WriteKeyword(keyword)

        /// <summary>
        /// Ű 
        /// </summary>
        /// <param name="keyword">Ű</param>
        public void WriteKeyword(string keyword)
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteKeyword(keyword);
            }
        }

        #endregion
        #region Ű  - WriteKeyword(keyword, externKeyword)

        /// <summary>
        /// Ű 
        /// </summary>
        /// <param name="keyword">Ű</param>
        /// <param name="externKeyword">ܺ Ű </param>
        public void WriteKeyword(string keyword, bool externKeyword)
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteKeyword(keyword, externKeyword);
            }
        }

        #endregion
        #region   - WriteRaw(text)

        /// <summary>
        ///  
        /// </summary>
        /// <param name="text">ؽƮ</param>
        public void WriteRaw(string text)
        {
            if(this.collectDocumentInfo == false)
            {
                if(text != null)
                {
                    this.writer.WriteRaw(text);
                }
            }
        }

        #endregion
        #region ׵θ  - WriteBorder(dashStyle)

        /// <summary>
        /// ׵θ 
        /// </summary>
        /// <param name="dashStyle"> Ÿ</param>
        public void WriteBorder(DashStyle dashStyle)
        {
            if(this.collectDocumentInfo == false)
            {
                if(dashStyle == DashStyle.Dot)
                {
                    WriteKeyword("brdrdot");
                }
                else if(dashStyle == DashStyle.DashDot)
                {
                    WriteKeyword("brdrdashd");
                }
                else if(dashStyle == DashStyle.DashDotDot)
                {
                    WriteKeyword("brdrdashdd");
                }
                else if(dashStyle == DashStyle.Dash)
                {
                    WriteKeyword("brdrdash");
                }
                else
                {
                    WriteKeyword("brdrs");
                }
            }
        }

        #endregion
        #region    - WriteStartDocument()

        /// <summary>
        ///   
        /// </summary>
        public void WriteStartDocument()
        {
            this.lastParagraphInfo = null;

            this.firstParagraph = true;

            if(this.collectDocumentInfo)
            {
                this.documentInfoHashtable.Clear();

                this.fontTable.Clear();

                this.colorTable.Clear();

                this.fontTable.Add(Control.DefaultFont.Name);
            }
            else
            {
                this.writer.WriteStartGroup();

                this.writer.WriteKeyword(RTFConstant.RTF);

                this.writer.WriteKeyword("ansi");

                this.writer.WriteKeyword($"ansicpg{this.writer.Encoding.CodePage}");

                if(this.documentInfoHashtable.Count > 0)
                {
                    this.writer.WriteStartGroup();

                    this.writer.WriteKeyword("info");

                    foreach(string key in this.documentInfoHashtable.Keys)
                    {
                        this.writer.WriteStartGroup();

                        object value = this.documentInfoHashtable[key];

                        if(value is string)
                        {
                            this.writer.WriteKeyword(key);

                            this.writer.WriteText((string) value);
                        }
                        else if(value is int)
                        {
                            this.writer.WriteKeyword(key + value);
                        }
                        else if(value is DateTime)
                        {
                            DateTime dateTime = (DateTime)value;

                            this.writer.WriteKeyword(key);

                            this.writer.WriteKeyword("yr"  + dateTime.Year  );
                            this.writer.WriteKeyword("mo"  + dateTime.Month );
                            this.writer.WriteKeyword("dy"  + dateTime.Day   );
                            this.writer.WriteKeyword("hr"  + dateTime.Hour  );
                            this.writer.WriteKeyword("min" + dateTime.Minute);
                            this.writer.WriteKeyword("sec" + dateTime.Second);
                        }
                        else
                        {
                            this.writer.WriteKeyword(key);
                        }
                        
                        this.writer.WriteEndGroup();
                    }

                    this.writer.WriteEndGroup();
                }

                this.writer.WriteStartGroup();

                this.writer.WriteKeyword(RTFConstant.FONTTBL);

                for(int i = 0; i < this.fontTable.Count; i ++)
                {
                    this.writer.WriteStartGroup();

                    this.writer.WriteKeyword($"f{i}");

                    RTFFont font = this.fontTable[i];

                    this.writer.WriteText(font.Name);

                    if(font.CharacterSet != 1)
                    {
                        this.writer.WriteKeyword($"fcharset{font.CharacterSet}");
                    }

                    this.writer.WriteEndGroup();
                }

                this.writer.WriteEndGroup();

                this.writer.WriteStartGroup();

                this.writer.WriteKeyword(RTFConstant.COLORTBL);

                this.writer.WriteRaw(";");

                for(int i = 0; i < this.colorTable.Count; i++)
                {
                    Color color = this.colorTable[i];

                    this.writer.WriteKeyword("red"   + color.R);
                    this.writer.WriteKeyword("green" + color.G);
                    this.writer.WriteKeyword("blue"  + color.B);

                    this.writer.WriteRaw(";");
                }

                this.writer.WriteEndGroup();

                if(ListTable != null && ListTable.Count > 0)
                {
                    if(DebugMode)
                    {
                        this.writer.WriteRaw(Environment.NewLine);
                    }

                    this.writer.WriteStartGroup();

                    this.writer.WriteKeyword("listtable", true);

                    foreach(RTFList list in ListTable)
                    {
                        if(DebugMode)
                        {
                            this.writer.WriteRaw(Environment.NewLine);
                        }

                        this.writer.WriteStartGroup();

                        this.writer.WriteKeyword("list");

                        this.writer.WriteKeyword($"listtemplateid{list.ListTemplateID}");

                        if(list.ListHybrid)
                        {
                            this.writer.WriteKeyword("listhybrid");
                        }

                        if(DebugMode)
                        {
                            this.writer.WriteRaw(Environment.NewLine);
                        }

                        this.writer.WriteStartGroup();

                        this.writer.WriteKeyword("listlevel");

                        this.writer.WriteKeyword($"levelfollow{list.LevelFollow}");

                        this.writer.WriteKeyword($"leveljc{list.JCLevel}");

                        this.writer.WriteKeyword($"levelstartat{list.LevelStartAt}");

                        this.writer.WriteKeyword($"levelnfc{Convert.ToInt32(list.NFCLevelNumberType)}");

                        this.writer.WriteKeyword($"levelnfcn{Convert.ToInt32(list.NFCLevelNumberType)}");

                        this.writer.WriteKeyword($"leveljc{list.JCLevel}");
                        
                        if(string.IsNullOrEmpty(list.LevelText) == false)
                        {
                            this.writer.WriteStartGroup();

                            this.writer.WriteKeyword("leveltext");

                            this.writer.WriteKeyword($"'0{list.LevelText.Length}");

                            if(list.NFCLevelNumberType == LevelNumberType.BULLET)
                            {
                                this.writer.WriteUnicodeText(list.LevelText);
                            }
                            else
                            {
                                this.writer.WriteText(list.LevelText, false);


                            }

                            this.writer.WriteEndGroup();

                            if(list.NFCLevelNumberType == LevelNumberType.BULLET)
                            {
                                RTFFont font = FontTable["Wingdings"];

                                if(font != null)
                                {
                                    this.writer.WriteKeyword($"f{font.Index}");
                                }
                            }
                            else
                            {
                                this.writer.WriteStartGroup();

                                this.writer.WriteKeyword("levelnumbers");

                                this.writer.WriteKeyword("'01");

                                this.writer.WriteEndGroup();
                            }
                        }

                        this.writer.WriteEndGroup();

                        this.writer.WriteKeyword($"listid{list.ListID}");

                        this.writer.WriteEndGroup();
                    }

                    this.writer.WriteEndGroup();
                }

                if(ListOverrideTable != null && ListOverrideTable.Count > 0)
                {
                    if(DebugMode)
                    {
                        this.writer.WriteRaw(Environment.NewLine);
                    }

                    this.writer.WriteStartGroup();

                    this.writer.WriteKeyword("listoverridetable");

                    foreach(RTFListOverride listOverride in ListOverrideTable)
                    {
                        if(DebugMode)
                        {
                            this.writer.WriteRaw(Environment.NewLine);
                        }

                        this.writer.WriteStartGroup();

                        this.writer.WriteKeyword("listoverride");

                        this.writer.WriteKeyword($"listid{listOverride.ListID}");

                        this.writer.WriteKeyword($"listoverridecount{listOverride.ListOverriedCount}");

                        this.writer.WriteKeyword($"ls{listOverride.ID}");

                        this.writer.WriteEndGroup();
                    }

                    this.writer.WriteEndGroup();
                }

                if(DebugMode)
                {
                    this.writer.WriteRaw(Environment.NewLine);
                }

                this.writer.WriteKeyword("viewkind1");
            }
        }

        #endregion
        #region    - WriteEndDocument()

        /// <summary>
        ///   
        /// </summary>
        public void WriteEndDocument()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteEndGroup();
            }

            this.writer.Flush();
        }

        #endregion
        #region Ӹ   - WriteStartHeader()

        /// <summary>
        /// Ӹ  
        /// </summary>
        public void WriteStartHeader()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("header");
            }
        }

        #endregion
        #region Ӹ   - WriteEndHeader()

        /// <summary>
        /// Ӹ  
        /// </summary>
        public void WriteEndHeader()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteEndGroup();
            }
        }

        #endregion
        #region ٴڱ   - WriteStartFooter()

        /// <summary>
        /// ٴڱ  
        /// </summary>
        public void WriteStartFooter()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("footer");
            }
        }

        #endregion
        #region ٴڱ   - WriteEndFooter()

        /// <summary>
        /// ٴڱ  
        /// </summary>
        public void WriteEndFooter()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteEndGroup();
            }
        }

        #endregion
        #region    - WriteStartParagraph()

        /// <summary>
        ///   
        /// </summary>
        public void WriteStartParagraph()
        {
            WriteStartParagraph(new RTFDocumentFormatInfo());
        }

        #endregion
        #region    - WriteStartParagraph(format)

        /// <summary>
        ///   
        /// </summary>
        /// <param name="format">  </param>
        public void WriteStartParagraph(RTFDocumentFormatInfo format)
        {
            if(this.collectDocumentInfo)
            {
            }
            else
            {
                if(this.firstParagraph)
                {
                    this.firstParagraph = false;

                    this.writer.WriteRaw(Environment.NewLine);
                }
                else
                {
                    this.writer.WriteKeyword("par");
                }

                if(format.ListID >= 0)
                {
                    this.writer.WriteKeyword("pard");

                    this.writer.WriteKeyword($"ls{format.ListID}");
                }

                if(this.lastParagraphInfo != null)
                {
                    if(this.lastParagraphInfo.ListID >= 0)
                    {
                        this.writer.WriteKeyword("pard");
                    }
                }

                switch(format.TextAlignment)
                {
                    case RTFTextAlignment.LEFT :

                        this.writer.WriteKeyword("ql");

                        break;

                    case RTFTextAlignment.CENTER :

                        this.writer.WriteKeyword("qc");

                        break;

                    case RTFTextAlignment.RIGHT :

                        this.writer.WriteKeyword("qr");

                        break;

                    case RTFTextAlignment.JUSTIFY :

                        this.writer.WriteKeyword("qj");

                        break;
                }

                if(format.ParagraphFirstLineIndent != 0)
                {
                    this.writer.WriteKeyword($"fi{Convert.ToInt32(format.ParagraphFirstLineIndent * 400 / format.StandTabWidth)}");
                }
                else
                {
                    this.writer.WriteKeyword("fi0");
                }

                if(format.LeftIndent != 0)
                {
                    this.writer.WriteKeyword($"li{Convert.ToInt32(format.LeftIndent * 400 / format.StandTabWidth)}");
                }
                else
                {
                    this.writer.WriteKeyword("li0");
                }

                this.writer.WriteKeyword("plain");
            }

            this.lastParagraphInfo = format ;
        }

        #endregion
        #region    - WriteEndParagraph()

        /// <summary>
        ///   
        /// </summary>
        public void WriteEndParagraph()
        {
        }

        #endregion
        #region ؽƮ  - WriteText(text)

        /// <summary>
        /// ؽƮ 
        /// </summary>
        /// <param name="text">ؽƮ</param>
        public void WriteText(string text)
        {
            if(text != null && this.collectDocumentInfo == false)
            {
                this.writer.WriteText(text);
            }
        }

        #endregion
        #region Ʈ  - WriteFont(font)

        /// <summary>
        /// Ʈ 
        /// </summary>
        /// <param name="font">Ʈ</param>
        public void WriteFont(Font font)
        {
            if(font == null)
            {
                throw new ArgumentNullException("font");
            }

            if(this.collectDocumentInfo)
            {
                this.fontTable.Add(font.Name);
            }
            else
            {
                int index = this.fontTable.GetIndex(font.Name);

                if(index >= 0)
                {
                    this.writer.WriteKeyword($"f{index}");
                }

                if(font.Bold)
                {
                    this.writer.WriteKeyword("b");
                }

                if(font.Italic)
                {
                    this.writer.WriteKeyword("i");
                }

                if(font.Underline)
                {
                    this.writer.WriteKeyword("ul");
                }

                if(font.Strikeout)
                {
                    this.writer.WriteKeyword("strike");
                }

                this.writer.WriteKeyword($"fs{Convert.ToInt32(font.Size * 2)}");
            }
        }

        #endregion
        #region ڿ   - WriteStartString(format)

        /// <summary>
        /// ڿ  
        /// </summary>
        /// <param name="format">  </param>
        public void WriteStartString(RTFDocumentFormatInfo format)
        {
            if(this.collectDocumentInfo)
            {
                this.fontTable.Add(format.FontName);

                this.colorTable.Add(format.TextColor);

                this.colorTable.Add(format.BackgroundColor);

                if(format.BorderColor.A != 0)
                {
                    this.colorTable.Add(format.BorderColor);
                }

                return;
            }

            if(format.Link != null && format.Link.Length > 0)
            {
                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("field");

                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("fldinst", true);

                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("hich");

                this.writer.WriteText($" HYPERLINK \"{format.Link}\"");

                this.writer.WriteEndGroup();

                this.writer.WriteEndGroup();

                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("fldrslt");

                this.writer.WriteStartGroup();
            }

            switch(format.TextAlignment)
            {
                case RTFTextAlignment.LEFT :

                    this.writer.WriteKeyword("ql");

                    break;

                case RTFTextAlignment.CENTER :

                    this.writer.WriteKeyword("qc");

                    break;

                case RTFTextAlignment.RIGHT :

                    this.writer.WriteKeyword("qr");

                    break;

                case RTFTextAlignment.JUSTIFY :

                    this.writer.WriteKeyword("qj");

                    break;
            }

            this.writer.WriteKeyword("plain");

            int index = this.fontTable.GetIndex(format.FontName);

            if(index >= 0)
            {
                this.writer.WriteKeyword($"f{index}");
            }

            if(format.Bold)
            {
                this.writer.WriteKeyword("b");
            }

            if(format.Italic)
            {
                this.writer.WriteKeyword("i");
            }

            if(format.Underline)
            {
                this.writer.WriteKeyword("ul");
            }

            if(format.Strikeout)
            {
                this.writer.WriteKeyword("strike");
            }

            this.writer.WriteKeyword($"fs{Convert.ToInt32(format.FontSize * 2)}");

            index = this.colorTable.GetIndex(format.BackgroundColor);

            if(index >= 0)
            {
                this.writer.WriteKeyword($"chcbpat{Convert.ToString(index + 1)}");
            }

            index = this.colorTable.GetIndex(format.TextColor);

            if(index >= 0)
            {
                this.writer.WriteKeyword($"cf{Convert.ToString(index + 1)}");
            }

            if(format.Subscript)
            {
                this.writer.WriteKeyword("sub");
            }

            if(format.Superscript)
            {
                this.writer.WriteKeyword("super");
            }

            if(format.NoWrap)
            {
                this.writer.WriteKeyword("nowwrap");
            }

            if(format.LeftBorder || format.TopBorder || format.RightBorder || format.BottomBorder)
            {
                if(format.BorderColor.A != 0)
                {
                    this.writer.WriteKeyword("chbrdr" );
                    this.writer.WriteKeyword("brdrs"  );
                    this.writer.WriteKeyword("brdrw10");

                    index = this.colorTable.GetIndex(format.BorderColor);

                    if(index >= 0)
                    {
                        this.writer.WriteKeyword($"brdrcf{Convert.ToString(index + 1)}");
                    }
                }
            }
        }

        #endregion
        #region ڿ   - WriteEndString(format)

        /// <summary>
        /// ڿ  
        /// </summary>
        /// <param name="format">  </param>
        public void WriteEndString(RTFDocumentFormatInfo format)
        {
            if(this.collectDocumentInfo)
            {
                return ;
            }
            
            if(format.Subscript)
            {
                this.writer.WriteKeyword("sub0");
            }

            if(format.Superscript)
            {
                this.writer.WriteKeyword("super0");
            }

            if(format.Bold)
            {
                this.writer.WriteKeyword("b0");
            }

            if(format.Italic)
            {
                this.writer.WriteKeyword("i0");
            }

            if(format.Underline)
            {
                this.writer.WriteKeyword("ul0");
            }

            if(format.Strikeout)
            {
                this.writer.WriteKeyword("strike0");
            }

            if(format.Link != null && format.Link.Length > 0)
            {
                this.writer.WriteEndGroup();
                this.writer.WriteEndGroup();
                this.writer.WriteEndGroup();
            }
        }

        #endregion
        #region ڿ  - WriteString(text , format)

        /// <summary>
        /// ڿ 
        /// </summary>
        /// <param name="text">ؽƮ</param>
        /// <param name="format">  </param>
        public void WriteString(string text , RTFDocumentFormatInfo format)
        {
            if(this.collectDocumentInfo)
            {
                this.fontTable.Add(format.FontName);

                this.colorTable.Add(format.TextColor);

                this.colorTable.Add(format.BackgroundColor);
            }
            else
            {
                this.WriteStartString(format);

                if(format.MultiLine)
                {
                    if(text != null)
                    {
                        text = text.Replace("\n", string.Empty);

                        StringReader reader = new StringReader(text);

                        string line = reader.ReadLine();

                        int i = 0 ;

                        while(line != null)
                        {
                            if(i > 0)
                            {
                                this.writer.WriteKeyword("line");
                            }

                            i++;

                            this.writer.WriteText(line);

                            line = reader.ReadLine();
                        }

                        reader.Close();
                    }
                }
                else
                {
                    this.writer.WriteText(text);
                }

                this.WriteEndString(format);
            }
        }

        #endregion
        #region ϸũ   - WriteStartBookmark(bookmarkName)

        /// <summary>
        /// ϸũ  
        /// </summary>
        /// <param name="bookmarkName">ϸũ</param>
        public void WriteStartBookmark(string bookmarkName)
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("bkmkstart" , true);

                this.writer.WriteKeyword("f0");

                this.writer.WriteText(bookmarkName);

                this.writer.WriteEndGroup();

                this.writer.WriteStartGroup();

                this.writer.WriteKeyword("bkmkend" , true);

                this.writer.WriteKeyword("f0");

                this.writer.WriteText(bookmarkName);

                this.writer.WriteEndGroup();
            }
        }

        #endregion
        #region  극ũ  - WriteLineBreak()

        /// <summary>
        ///  극ũ 
        /// </summary>
        public void WriteLineBreak()
        {
            if(this.collectDocumentInfo == false)
            {
                this.writer.WriteKeyword("line");
            }
        }

        #endregion
        #region ̹  - WriteImage(image, width, height, imageByteArray)

        /// <summary>
        /// ̹ 
        /// </summary>
        /// <param name="image">̹</param>
        /// <param name="width">ʺ</param>
        /// <param name="height"></param>
        /// <param name="imageByteArray">̹ Ʈ 迭</param>
        public void WriteImage(Image image, int width, int height, byte[] imageByteArray)
        {
            if(this.collectDocumentInfo)
            {
                return;
            }
            else
            {
                if(imageByteArray == null)
                {
                    return;
                }

                MemoryStream memoryStream = new MemoryStream();

                image.Save(memoryStream, ImageFormat.Jpeg);

                memoryStream.Close();

                byte[] byteArray = memoryStream.ToArray();

                this.writer.WriteStartGroup();
                
                this.writer.WriteKeyword("pict");

                this.writer.WriteKeyword("jpegblip");

                this.writer.WriteKeyword($"picscalex{Convert.ToInt32(width  * 100.0 / image.Size.Width )}");
                this.writer.WriteKeyword($"picscaley{Convert.ToInt32(height * 100.0 / image.Size.Height)}");

                this.writer.WriteKeyword($"picwgoal{Convert.ToString(image.Size.Width  * 15)}");
                this.writer.WriteKeyword($"pichgoal{Convert.ToString(image.Size.Height * 15)}");

                this.writer.WriteByteArray(byteArray);

                this.writer.WriteEndGroup();
            }
        }

        #endregion
        #region ݱ - Close()

        /// <summary>
        /// ݱ
        /// </summary>
        public virtual void Close()
        {
            this.writer.Close();
        }

        #endregion
    }
}