﻿using System;

namespace TestLibrary
{
    /// <summary>
    /// RTF 리스트
    /// </summary>
    public class RTFList
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 리스트 ID
        /// </summary>
        private int listID = 0;

        /// <summary>
        /// 리스트명
        /// </summary>
        private string listName = null;

        /// <summary>
        /// 리스트 템플리트 ID
        /// </summary>
        private int listTemplateID = 0;

        /// <summary>
        /// 리스트 SIMPLE 여부
        /// </summary>
        private bool listSimple = false;

        /// <summary>
        /// 리스트 HYBRID 여부
        /// </summary>
        private bool listHybrid = false;

        /// <summary>
        /// 리스트 스타일명
        /// </summary>
        private string listStyleName = null;

        /// <summary>
        /// 시작 레벨
        /// </summary>
        private int levelStartAt = 1;

        /// <summary>
        /// NFC 레벨 번호 타입
        /// </summary>
        private LevelNumberType nfcLevelNumberType =  LevelNumberType.NONE  ;

        /// <summary>
        /// JC 레벨
        /// </summary>
        private int jcLevel = 0;

        /// <summary>
        /// 레벨 팔로우
        /// </summary>
        private int levelFollow = 0;

        /// <summary>
        /// 폰트명
        /// </summary>
        private string fontName = null;

        /// <summary>
        /// 레벨 텍스트
        /// </summary>
        private string levelText = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 리스트 ID - ListID

        /// <summary>
        /// 리스트 ID
        /// </summary>
        public int ListID
        {
            get
            {
                return this.listID;
            }
            set
            {
                this.listID = value;
            }
        }

        #endregion
        #region 리스트명 - ListName

        /// <summary>
        /// 리스트명
        /// </summary>
        public string ListName
        {
            get
            {
                return this.listName;
            }
            set
            {
                this.listName = value;
            }
        }

        #endregion
        #region 리스트 템플리트 ID - ListTemplateID

        /// <summary>
        /// 리스트 템플리트 ID
        /// </summary>
        public int ListTemplateID
        {
            get
            {
                return this.listTemplateID;
            }
            set
            {
                this.listTemplateID = value;
            }
        }

        #endregion
        #region 리스트 SIMPLE 여부 - ListSimple

        /// <summary>
        /// 리스트 SIMPLE 여부
        /// </summary>
        public bool ListSimple
        {
            get
            {
                return this.listSimple;
            }
            set
            {
                this.listSimple = value;
            }
        }

        #endregion
        #region 리스트 HYBRID 여부 - ListHybrid

        /// <summary>
        /// 리스트 HYBRID 여부
        /// </summary>
        public bool ListHybrid
        {
            get
            {
                return this.listHybrid;
            }
            set
            {
                this.listHybrid = value;
            }
        }

        #endregion
        #region 리스트 스타일명 - ListStyleName

        /// <summary>
        /// 리스트 스타일명
        /// </summary>
        public string ListStyleName
        {
            get
            {
                return this.listStyleName;
            }
            set
            {
                this.listStyleName = value;
            }
        }

        #endregion
        #region 시작 레벨 - LevelStartAt

        /// <summary>
        /// 시작 레벨
        /// </summary>
        public int LevelStartAt
        {
            get
            {
                return this.levelStartAt;
            }
            set
            {
                this.levelStartAt = value;
            }
        }

        #endregion
        #region NFC 레벨 번호 타입 - NFCLevelNumberType

        /// <summary>
        /// NFC 레벨 번호 타입
        /// </summary>
        public LevelNumberType NFCLevelNumberType
        {
            get
            {
                return this.nfcLevelNumberType;
            }
            set
            {
                this.nfcLevelNumberType = value;
            }
        }

        #endregion
        #region JC 레벨 - JCLevel

        /// <summary>
        /// JC 레벨
        /// </summary>
        public int JCLevel
        {
            get
            {
                return this.jcLevel;
            }
            set
            {
                this.jcLevel = value;
            }
        }

        #endregion
        #region 레벨 팔로우 - LevelFollow

        /// <summary>
        /// 레벨 팔로우
        /// </summary>
        public int LevelFollow
        {
            get
            {
                return this.levelFollow;
            }
            set
            {
                this.levelFollow = value;
            }
        }

        #endregion
        #region 폰트명 - FontName

        /// <summary>
        /// 폰트명
        /// </summary>
        public string FontName
        {
            get
            {
                return this.fontName;
            }
            set
            {
                this.fontName = value;
            }
        }

        #endregion
        #region 레벨 텍스트 - LevelText

        /// <summary>
        /// 레벨 텍스트
        /// </summary>
        public string LevelText
        {
            get
            {
                return this.levelText;
            }
            set
            {
                this.levelText = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 문자열 구하기 - ToString()

        /// <summary>
        /// 문자열 구하기
        /// </summary>
        /// <returns>문자열</returns>
        public override string ToString()
        {
            if(NFCLevelNumberType == LevelNumberType.BULLET)
            {
                string text = $"ID:{ListID}   Bullet:";

                if(string.IsNullOrEmpty(LevelText) == false)
                {
                    text = $"{text}({Convert.ToString((short)this.LevelText[0])})";
                }

                return text;
            }
            else
            {
                return  $"ID:{ListID} {NFCLevelNumberType.ToString()} Start:{LevelStartAt}";
            }
        }

        #endregion
    }
}