using System;
using System.Collections;
using System.Diagnostics;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF  Ʈ
    /// </summary>
    [DebuggerDisplay("Count={Count}")]
    [DebuggerTypeProxy(typeof(RTFInstanceDebugView))]
    public class RTFNodeList : CollectionBase
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ε - this[index]

        /// <summary>
        /// ε
        /// </summary>
        public RTFNode this[int index]
        {
            get
            {
                return (RTFNode)List[index];
            }
        }

        #endregion
        #region ε - this[keyword]

        /// <summary>
        /// ε
        /// </summary>
        public RTFNode this[string Keyword]
        {
            get
            {
                foreach(RTFNode node in this)
                {
                    if(node.Keyword == Keyword)
                    {
                        return node;
                    }
                }

                return null;
            }
        }

        #endregion
        #region ε - this[type]

        /// <summary>
        /// ε
        /// </summary>
        public RTFNode this[Type type]
        {
            get
            {
                foreach(RTFNode node in this)
                {
                    if(type.Equals(node.GetType()))
                    {
                        return node;
                    }
                }

                return null;
            }
        }

        #endregion
        #region ؽƮ - Text

        /// <summary>
        /// ؽƮ
        /// </summary>
        public string Text
        {
            get
            {
                StringBuilder stringBuilder = new StringBuilder();

                foreach(RTFNode node in this)
                {
                    if(node.NodeType == RTFNodeType.TEXT)
                    {
                        stringBuilder.Append(node.Keyword);
                    }
                    else if(node is RTFNodeGroup)
                    {
                        string text = node.ChildNodeList.Text ;

                        if(text != null)
                        {
                            stringBuilder.Append(text);
                        }
                    }
                }
                return stringBuilder.ToString();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region Ű  ϱ - GetParameter(key, defaultValue)

        /// <summary>
        /// Ű  ϱ
        /// </summary>
        /// <param name="key">Ű</param>
        /// <param name="defaultValue">Ʈ </param>
        /// <returns>Ű </returns>
        public int GetParameter(string key, int defaultValue)
        {
            foreach(RTFNode node in this)
            {
                if(node.Keyword == key && node.HasParameter)
                {
                    return node.Parameter;
                }
            }

            return defaultValue;
        }

        #endregion
        #region Ű   ϱ - ContainsKey(Key)

        /// <summary>
        /// Ű   ϱ
        /// </summary>
        /// <param name="Key">Ű</param>
        /// <returns>Ű  </returns>
        public bool ContainsKey(string Key)
        {
            return this[Key] != null;
        }

        #endregion
        #region ε ϱ - GetIndex(node)

        /// <summary>
        /// ε ϱ
        /// </summary>
        /// <param name="node">RTF </param>
        /// <returns>ε</returns>
        public int GetIndex(RTFNode node)
        {
            return List.IndexOf(node);
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region ߰ϱ - Add(node)

        /// <summary>
        /// ߰ϱ
        /// </summary>
        /// <param name="node"></param>
        internal void Add(RTFNode node)
        {
            List.Add(node);
        }

        #endregion
        #region ϱ - Insert(index , node)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="index">ε</param>
        /// <param name="node"></param>
        internal void Insert(int index , RTFNode node)
        {
            List.Insert(index, node);
        }

        #endregion
        #region  ߰ϱ - AddRange(nodeList)

        /// <summary>
        ///  ߰ϱ
        /// </summary>
        /// <param name="nodeList"> Ʈ</param>
        internal void AddRange(RTFNodeList nodeList)
        {
            InnerList.AddRange(nodeList);
        }

        #endregion
        #region ϱ - Remove(node)

        /// <summary>
        /// ϱ
        /// </summary>
        /// <param name="node"></param>
        internal void Remove(RTFNode node)
        {
            Remove(node);
        }

        #endregion
    }
}