﻿namespace TestLibrary
{
    /// <summary>
    /// RTF 원시 레이어 정보
    /// </summary>
    public class RTFRawLayerInfo
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// UC 값
        /// </summary>
        private int ucValue = 0;

        /// <summary>
        /// UC 값 카운트
        /// </summary>
        private int ucValueCount = 0;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region UC 값 - UCValue

        /// <summary>
        /// UC 값
        /// </summary>
        public int UCValue
        {
            get
            {
                return this.ucValue;
            }
            set
            {
                this.ucValue      = value;
                this.ucValueCount = 0;
            }
        }

        #endregion
        #region UC 값 카운트 - UCValueCount

        /// <summary>
        /// UC 값 카운트
        /// </summary>
        public int UCValueCount
        {
            get
            {
                return this.ucValueCount;
            }
            set
            {
                this.ucValueCount = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region UC 값 카운트 체크하기 - CheckUCValueCount()

        /// <summary>
        /// UC 값 카운트 체크하기
        /// </summary>
        /// <returns>UC 값 카운트 체크 결과</returns>
        public bool CheckUCValueCount()
        {
            this.ucValueCount--;

            return this.ucValueCount < 0;
        }

        #endregion
        #region 복제하기 - Clone()

        /// <summary>
        /// 복제하기
        /// </summary>
        /// <returns>RTF 원시 레이어 정보</returns>
        public RTFRawLayerInfo Clone()
        {
            return (RTFRawLayerInfo)MemberwiseClone();
        }

        #endregion
    }
}